<?php
/*
*
* Copyright (c) 2014 AM Data Soft
* Distributed under the GNU GPL v3.
* License: http://www.gnu.org/licenses/gpl.html GPL version 3 or higher
*
*/

/*
*
* Purpose:         Company Read only view (reference only)
*                  DO NOT modify this file. Changing this file may void your support
* Developer:       AM Data Soft
* Version:         1.0
* Version date:    2014-04-10
*
*/

session_start();

require_once('settings.php');

date_default_timezone_set(DEFAULT_TIMEZONE);
define('SID', session_id());
define('CURRENT_PAGE', $_SERVER['SCRIPT_NAME']);
define('CURRENT_SCRIPT', $_SERVER['SCRIPT_FILENAME']);
define('CURRENT_URL',$_SERVER['REQUEST_URI']);

require_once(WEB_ROOT.'/lib/rest_client.php');
require_once(WEB_ROOT.'/incl/security.php');
require_once(WEB_ROOT.'/incl/top.php');

// let's gather some info about our company

// users data:

if (!isset($_SESSION['users_list'])){
    $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
    $rest_client = new rest_client($_SESSION['auth_head'],'');
    $users_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/user',json_encode($comp_id,true));
    $arr_users_list = json_decode($users_list_return, true);
    if(count($arr_users_list) > 0){
        $_SESSION['users_list'] = $arr_users_list;
        $_SESSION['users_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
    }
}
$inactive_users = 0;
$active_users = 0;
$admin_users = 0;
$manager_users = 0;
$all_users = count($_SESSION['users_list']['item_list']);
foreach ($_SESSION['users_list']['item_list'] as $user_data) {
    $cur_user = $utilities_library->mk_array($user_data['key'],$user_data['property_list']);    
    if($cur_user['active_yn'] == 'True'){
        $active_users = $active_users + 1;
    }else{
        $inactive_users = $inactive_users + 1;
    }
    if($cur_user['access_level'] == 'ADMIN'){
        $admin_users = $admin_users + 1;
    }
    if($cur_user['access_level'] == 'MANAGER'){
        $manager_users = $manager_users + 1;
    }
}

// devices data:

if (!isset($_SESSION['devices_list'])){
    $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
    $rest_client = new rest_client($_SESSION['auth_head'],'');
    $devices_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/devices',json_encode($comp_id,true));
    $arr_devices_list = json_decode($devices_list_return, true);
    if(count($arr_devices_list) > 0){
        $_SESSION['devices_list'] = $arr_devices_list;
        $_SESSION['devices_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
    }
}
$inactive_devices = 0;
$active_devices = 0;
$all_devices = count($_SESSION['devices_list']['item_list']);
foreach ($_SESSION['devices_list']['item_list'] as $server_data) {
    $cur_user = $utilities_library->mk_array($server_data['key'],$server_data['property_list']);
    if($cur_user['active_yn'] == 'True'){
        $active_devices = $active_devices + 1;
    }else{
        $inactive_devices = $inactive_devices + 1;
    }
}

$comp_id = [
'company_id' => $_SESSION['auth_head']['auth_head_company_id']
];
$rest_client = new rest_client($_SESSION['auth_head'],'');
$files_list_return = $rest_client->sum(WEB_SERVICE_ADDRESS.'/files',json_encode($comp_id,true));
$tf_size = json_decode($files_list_return,true);
$used_storage = $tf_size['size'];

?>

<body>

<?php
require_once(WEB_ROOT.'/incl/head.php');
?>

    <div class="container">

    <h2 class="form-signin-heading"><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_pghead_company', DEFAULT_LANG); ?></h2>

<div class="panel-group" id="accordion">
  <div class="panel panel-default">
    <div class="panel-heading">
      <h4 class="panel-title">
        <a data-toggle="collapse" data-parent="#accordion" href="#collapseOne">
        <?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_tab_company_info', DEFAULT_LANG); ?>
        </a>
      </h4>
    </div>
    <div id="collapseOne" class="panel-collapse collapse in">
      <div class="panel-body">

                    <div class="row">
                        <div class="col-lg-6">
                            <table class="table table-striped">
                                <tr>
                                    <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_company_name', DEFAULT_LANG); ?></strong></td>
                                    <td><?php echo $_SESSION['company_data']['company_name'];?></td>
                                </tr>
                                <tr>
                                    <td valign="top"><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_office_address1', DEFAULT_LANG); ?></strong></td>
                                    <td><?php 
                                        echo $_SESSION['company_data']['address1']." ".$_SESSION['company_data']['address2']."<br />";
                                        echo $_SESSION['company_data']['city']." ".$_SESSION['company_data']['region']." ".$_SESSION['company_data']['postcode']."<br />";
                                        echo $_SESSION['company_data']['country'];
                                    ?></td>
                                </tr>
                                <tr>
                                    <td valign="top"><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_contact_person', DEFAULT_LANG); ?></strong></td>
                                    <td><?php 
                                        echo "<strong>".$_SESSION['company_data']['contact_person_fname']." ".$_SESSION['company_data']['contact_person_lname']."</strong><br />";
                                        echo $_SESSION['company_data']['contact_person_address1']." ".$_SESSION['company_data']['contact_person_address2']."<br />";
                                        echo $_SESSION['company_data']['contact_person_city']." ".$_SESSION['company_data']['contact_person_region']." ".$_SESSION['company_data']['contact_person_postcode']."<br />";
                                        echo $_SESSION['company_data']['contact_person_country']."<br />";
                                        echo $formatting_library->make_lang_label($arr_labels, 'lbl_office_phone', DEFAULT_LANG).": ".$_SESSION['company_data']['contact_person_office_phone']."<br />";
                                        echo $formatting_library->make_lang_label($arr_labels, 'lbl_office_cellphone', DEFAULT_LANG).": ".$_SESSION['company_data']['contact_person_office_cellphone']."<br />";
                                        echo $formatting_library->make_lang_label($arr_labels, 'lbl_office_email', DEFAULT_LANG).": ".$_SESSION['company_data']['contact_person_office_email']."<br />";
                                    ?></td>
                                </tr>
                                <tr>
                                    <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_language', DEFAULT_LANG); ?></strong></td>
                                    <td><?php echo $_SESSION['company_data']['lang_env'];?></td>
                                </tr>
                                <tr>
                                    <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_timezone', DEFAULT_LANG); ?></strong></td>
                                    <td><?php echo $_SESSION['company_data']['timezone'];?></td>
                                </tr>
                                <tr>
                                    <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_last_modified', DEFAULT_LANG); ?></strong></td>
                                    <td><?php echo $utilities_library->mk_dt($_SESSION['company_data']['modified_on'],'Y-m-d H:i:s',DATETIME_FORMAT); ?></td>
                                </tr>
                            </table>
                        </div>
                    </div>

      </div>
    </div>
  </div>
  <div class="panel panel-default">
    <div class="panel-heading">
      <h4 class="panel-title">
        <a data-toggle="collapse" data-parent="#accordion" href="#collapseTwo">
                    <?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_tab_company_licensing', DEFAULT_LANG); ?>
        </a>
      </h4>
    </div>
    <div id="collapseTwo" class="panel-collapse collapse">
      <div class="panel-body">
                    
                    
                    <div class="row">
                        <div class="col-lg-6">
                            <table class="table table-striped">
                                <tr>
                                    <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_company_key', DEFAULT_LANG); ?></strong></td>
                                    <td><?php echo $_SESSION['company_data']['key'];?></td>
                                </tr>
                                <tr>
                                    <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_since', DEFAULT_LANG); ?></strong></td>
                                    <td><?php echo $utilities_library->mk_dt($_SESSION['company_data']['created_on'],'Y-m-d H:i:s','Y-m-d'); ?></td>
                                </tr>
                                <?php 
                                    $lic_start = new DateTime("".gmdate('Y')."-".gmdate('M')."-".gmdate('d')."");
                                    $lic_end = new DateTime($utilities_library->mk_dt($_SESSION['company_data']['expired_on'],'Y-m-d H:i:s','Y-m-d'));
                                    $interval = $lic_start->diff($lic_end);
                                    $num_days = $interval->format('%a');

                                    if($num_days < 30 && $num_days >= 7){
                                        echo "<tr class=\"warning\">";
                                    }else if($num_days < 7 && $num_days > 1){
                                        echo "<tr class=\"danger\">";
                                    }else if($num_days <= 1){
                                        echo "<tr class=\"danger\">";
                                    }else{
                                        echo "<tr class=\"success\">";
                                    }
                                ?>
                                    <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_until', DEFAULT_LANG); ?></strong></td>
                                    <td>
                                    <?php

                                        if($num_days < 30 && $num_days >= 7){
                                            echo $utilities_library->mk_dt($_SESSION['company_data']['expired_on'],'Y-m-d H:i:s','Y-m-d')." [".$formatting_library->make_lang_label($arr_labels, 'lbl_less_than_month', DEFAULT_LANG)."]";
                                        }else if($num_days < 7 && $num_days > 1){
                                            echo $utilities_library->mk_dt($_SESSION['company_data']['expired_on'],'Y-m-d H:i:s','Y-m-d')." [".$formatting_library->make_lang_label($arr_labels, 'lbl_less_than_week', DEFAULT_LANG)."]";
                                        }else if($num_days <= 1){
                                            echo $utilities_library->mk_dt($_SESSION['company_data']['expired_on'],'Y-m-d H:i:s','Y-m-d')." [".$formatting_library->make_lang_label($arr_labels, 'lbl_today', DEFAULT_LANG)."]";
                                        }else{
                                            echo $utilities_library->mk_dt($_SESSION['company_data']['expired_on'],'Y-m-d H:i:s','Y-m-d')." [".$num_days." ".$formatting_library->make_lang_label($arr_labels, 'lbl_days', DEFAULT_LANG)."]";
                                        } 
                                    ?>
                                    </td>
                                </tr>
                                
                            </table>
                        </div>
                    </div>

      </div>
    </div>
  </div>
  <div class="panel panel-default">
    <div class="panel-heading">
      <h4 class="panel-title">
        <a data-toggle="collapse" data-parent="#accordion" href="#collapseThree">
            <?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_tab_company_usage', DEFAULT_LANG); ?>

        </a>
      </h4>
    </div>
    <div id="collapseThree" class="panel-collapse collapse">
      <div class="panel-body">

                    <div class="row">
                        <div class="col-lg-6">
                            <table class="table">
                                <tr>
                                    <td valign="top"><h4><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_pghead_users', DEFAULT_LANG); ?></h4></td>
                                    <td><?php 
                                        echo "<table class=\"table table-bordered\">";
                                        echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_all_users', DEFAULT_LANG).":</strong></td><td><strong>".$all_users."</strong></td></tr>";
                                        echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_inactive_users', DEFAULT_LANG).":</strong></td><td>".$inactive_users."</td></tr>";
                                        echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_active_users', DEFAULT_LANG).":</strong></td><td>".$active_users."</td></tr>";
                                        echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_admin_users', DEFAULT_LANG).":</strong></td><td>".$admin_users."</td></tr>";
                                        echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_manager_users', DEFAULT_LANG).":</strong></td><td>".$manager_users."</td></tr>";
                                        $users_diff = $_SESSION['company_data']['max_users'] - $active_users;
                                        if($users_diff < 20 && $users_diff >= 10){
                                            echo "<tr class=\"success\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_users', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_users']."</td></tr>";
                                        } else if($users_diff < 10 && $users_diff >= 5){
                                            echo "<tr class=\"warning\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_users', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_users']."</td></tr>";
                                        } else if($users_diff < 5 && $users_diff >= 0){
                                            echo "<tr class=\"danger\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_users', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_users']."</td></tr>";
                                        } else if($users_diff < 0){
                                            echo "<tr class=\"danger\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_users', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_users']."</td></tr>";
                                        }else{
                                            echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_users', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_users']."</td></tr>";
                                        }
                                        echo "</table>";
                                    ?></td>
                                </tr>
                                <tr>
                                    <td valign="top"><h4><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_pghead_devices', DEFAULT_LANG); ?></h4></td>
                                    <td><?php 
                                        echo "<table class=\"table table-bordered\">";
                                        echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_all_devices', DEFAULT_LANG).":</strong></td><td><strong>".$all_devices."</strong></td></tr>";
                                        echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_inactive_devices', DEFAULT_LANG).":</strong></td><td>".$inactive_devices."</td></tr>";
                                        echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_active_devices', DEFAULT_LANG).":</strong></td><td>".$active_devices."</td></tr>";
                                        $devices_diff = $_SESSION['company_data']['max_devices'] - $all_devices;
                                        if($devices_diff < 20 && $devices_diff >= 10){
                                            echo "<tr class=\"success\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_devices', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_devices']."</td></tr>";
                                        } else if($devices_diff < 10 && $devices_diff >= 5){
                                            echo "<tr class=\"warning\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_devices', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_devices']."</td></tr>";
                                        } else if($devices_diff < 5 && $devices_diff >= 0){
                                            echo "<tr class=\"danger\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_devices', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_devices']."</td></tr>";
                                        } else if($devices_diff < 0){
                                            echo "<tr class=\"danger\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_devices', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_devices']."</td></tr>";
                                        }else{
                                            echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_licensed_devices', DEFAULT_LANG).":</strong></td><td>".$_SESSION['company_data']['max_devices']."</td></tr>";
                                        }
                                        echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_max_storage', DEFAULT_LANG).":</strong></td><td>".round($_SESSION['company_data']['max_storage']/1024,0,PHP_ROUND_HALF_UP)." kb</td></tr>";
                                        $storage_diff = $_SESSION['company_data']['max_storage'] - $used_storage;
                                        if($storage_diff < 20971520 && $storage_diff >= 10485760){
                                            echo "<tr class=\"success\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_used_storage', DEFAULT_LANG).":</strong></td><td>".round($used_storage/1024,0,PHP_ROUND_HALF_UP)." kb</td></tr>";
                                        } else if($storage_diff < 10485760 && $storage_diff >= 5242880){
                                            echo "<tr class=\"warning\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_used_storage', DEFAULT_LANG).":</strong></td><td>".round($used_storage/1024,0,PHP_ROUND_HALF_UP)." kb</td></tr>";
                                        } else if($storage_diff < 5242880 && $storage_diff >= 0){
                                            echo "<tr class=\"danger\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_used_storage', DEFAULT_LANG).":</strong></td><td>".round($used_storage/1024,0,PHP_ROUND_HALF_UP)." kb</td></tr>";
                                        } else if($storage_diff < 0){
                                            echo "<tr class=\"danger\"><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_used_storage', DEFAULT_LANG).":</strong></td><td>".round($used_storage/1024,0,PHP_ROUND_HALF_UP)." kb</td></tr>";
                                        }else{
                                            echo "<tr><td><strong>".$formatting_library->make_lang_label($arr_labels, 'lbl_company_used_storage', DEFAULT_LANG).":</strong></td><td>".round($used_storage/1024,0,PHP_ROUND_HALF_UP)." kb</td></tr>";
                                        }
                                        echo "</table>";
                                    ?></td>
                                </tr>
                            </table>
                        </div>
                    </div> 
      </div>
    </div>
  </div>
</div>
    

<?php

require_once(WEB_ROOT.'/incl/bottom.php');

?>
