<?php
/*
*
* Copyright (c) 2014 AM Data Soft
* Distributed under the GNU GPL v3.
* License: http://www.gnu.org/licenses/gpl.html GPL version 3 or higher
*
*/

/*
*
* Purpose:         Head and meta information for the website.
*                  This file should not be changed or changed with extreme caution
*                  Consider only adding additional javascript and stylesheed files to this 
*                  module and do not remove any existing includes. The purpose of this file 
*                  is to provide a framework for the entire content of the site, so making 
*                  changes to existing scripts or references to scripts may damage the layout 
*                  and functionality of the web application.
* Developer:       AM Data Soft
* Version:         1.0
* Version date:    2014-04-10
*
*/
?>

<!DOCTYPE html>
<html lang="<?php echo DEFAULT_LANG; ?>">
  <head>

    <meta charset="utf-8">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <meta name="description" content=""/>
    <meta name="author" content=""/>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <!-- <meta http-equiv="X-UA-Compatible" content="IE=edge">-->
    <link rel="shortcut icon" href="<?php echo WEB_ADDRESS; ?>favicon.ico" type="image/x-icon">
    <link rel="icon" href="<?php echo WEB_ADDRESS; ?>favicon.png" sizes="32x32">

    <title><?php echo APP_NAME; ?></title>

    <!-- Bootstrap core CSS -->
    <link href="<?php echo WEB_ADDRESS; ?>css/bootstrap.css" rel="stylesheet"/>
    <link href="<?php echo WEB_ADDRESS; ?>css/docs.min.css" rel="stylesheet"/>
    <script type="text/javascript" src="<?php echo WEB_ADDRESS; ?>js/jquery.min.js"></script>
    <link href='http://fonts.googleapis.com/css?family=Lato:300,400' rel='stylesheet' type='text/css'/>
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.0.0/css/bootstrap-glyphicons.css" rel="stylesheet"/>

    <!-- Custom styles for this template -->
     <style type="text/css">
        html,
        body {
          height: 100%;
          padding-top: 25px;
          padding-bottom: 20px;
          /* 
          font-family:Lato,Lucida Sans Unicode;
          color:#000000;
          font-weight:300;
          */
          /* The html and body elements cannot have any padding or margin. */
        }

        /* Wrapper for page content to push down footer */
        #wrap {
          min-height: 100%;
          height: auto !important;
          height: 100%;
          /* Negative indent footer by its height */
          margin: 0 auto -60px;
          /* Pad bottom by footer height */
          padding: 0 0 60px;
        }

        /* Set the fixed height of the footer here */
        #footer {
          height: 60px;
          background-color: #f5f5f5;
        }

        /* Custom page CSS
        -------------------------------------------------- */
        /* Not required for template or sticky footer method. */

        #wrap > .container {
          padding: 60px 15px 0;
        }
        .container .credit {
          margin: 20px 0;
        }

        #footer > .container {
          padding-left: 15px;
          padding-right: 15px;
        }

        code {
          font-size: 80%;
        }

        .indexpg {
          padding: 10px;
          margin-bottom: 10px;
          font-size: 14px;
          font-weight: 200;
          line-height: 1.6;
          color: inherit;
          background-color: #eeeeee;
        }

        .indexpg h1 {
          line-height: 1;
          color: inherit;
        }

        .indexpg p {
          line-height: 1.4;
        }

        .container .indexpg {
          border-radius: 6px;
        }

        .Pane{
            display:table;
            height:100%;
            width:100%;
        }
        .Pane .Sub{
            display:table-cell;
            vertical-align:middle
            top:0;
        }
        .Below{
            min-height:100%;
            padding:1em;
        }
        .Info{
            border-spacing:0 1em;
            display:table;
            margin:0 auto;
            text-align:left;
            top:20px;
        }
        .Info > .Item{
            display:table-row;
        }
        .Info > .Item > .Left,.Info > .Item > .Right{
            display:table-cell;
            padding:8px 16px;
            padding:.5rem 1rem;
        }
        .Info > .Item > .Left{
            font-weight:400;
            padding-left:0;
            text-align:right;
            vertical-align:middle;
            font-family:Lato,Lucida Sans Unicode;
                    color:#000000;
            font-weight:600;
        }
        .Info > .Item > .Right{
            border-left:.125em solid #CCC;
            max-width:40em;
            padding-right:0;
            text-align:left;
            vertical-align:top;
            font-family:Lato,Lucida Sans Unicode;
                    color:#000000;
            font-weight:300;
        }

    }


     </style>

    <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="../../assets/js/html5shiv.js"></script>
      <script src="../../assets/js/respond.min.js"></script>
    <![endif]-->
    
     <style type="text/css">
        @media print {
        body * {
        visibility:hidden;
        }
        #printable, #printable * {
        visibility:visible;
        }
        #printable { /* aligning the printable area */
        position:absolute;
        left:40;
        top:40;
        }
        }
        .kd{display:inline-block;padding:6px 12px;margin-bottom:0;font-size:14px;font-weight:normal;line-height:1.428571429;text-align:center;white-space:nowrap;vertical-align:middle;cursor:pointer;border:1px solid transparent;border-radius:4px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;-o-user-select:none;user-select:none}
        .kd_sbmt{color:#fff;background-color:#5cb85c;border-color:#4cae4c}
        
        .pb_container {
            margin-top: 30px;
            width: 400px;
        }
        
        </style>


    <script type="text/javascript">
    function navigateTo(sel, target, newWindow) {
        var url = sel.options[sel.selectedIndex].value;
        if (newWindow) {
            window.open(url, target, '');
        } else {
            window[target].location.href = url;
        }
    }

    function PopupWindow(file, iWidth, iHeight, time)
    {
        iWidth  -= 10;
        iHeight -= 20;
        iX = (screen.width  - iWidth)  / 2;
        iY = (screen.height - iHeight) / 2;
        if(iX < 0) { iX = 0;  };
        if(iY < 0) { iY = 0; };
        style="left=" +iX+ ",top=" +iY+ ",width=" +iWidth+ ",height=" +iHeight+ ",toolbar=0,scrollbars=1,resizable=0,menubar=0,alwaysRaised=1";
        NewWindow = window.open(file,'LocationWindow',style);
    }


    //function printDiv(divName) {
    //     var printContents = document.getElementById(divName).innerHTML;
    //     var originalContents = document.body.innerHTML;
    //     document.body.innerHTML = printContents;
    //     window.print();
    //     document.body.innerHTML = originalContents;
    //}

        //function printElement(elem) {
        //    var domClone = elem.cloneNode(true);

        //    var $printSection = document.getElementById("printSection");

        //    if (!$printSection) {
        //        var $printSection = document.createElement("div");
        //        $printSection.id = "printSection";
        //        document.body.appendChild($printSection);
        //    }

        //    $printSection.innerHTML = "";
        //    $printSection.appendChild(domClone);
        //    window.print();
        //}

        function print_modal(elem_id) {
            w=window.open();
            w.document.write($(elem_id).html());
            w.print();
            w.close();
        }

    function delRow(tbl_name,row)
    {
        var cur_row = row.parentNode.parentNode.rowIndex;
        document.getElementById(tbl_name).deleteRow(cur_row);
    }

    function insRow(tbl_name)
    {
        var tbl = document.getElementById(tbl_name);
        var new_row = tbl.rows[1].cloneNode(true);

        var inp1 = new_row.cells[1].getElementsByTagName('div')[0];
        var inp2 = new_row.cells[2].getElementsByTagName('div')[0];
        var inp3 = new_row.cells[3].getElementsByTagName('div')[0];
        var inp4 = new_row.cells[4].getElementsByTagName('div')[0];
        var inp5 = new_row.cells[5].getElementsByTagName('div')[0];

        tbl.appendChild( new_row );
    }

    function delAcctRow(tbl_name,row)
    {
        var cur_row = row.parentNode.parentNode.rowIndex;
        document.getElementById(tbl_name).deleteRow(cur_row);
    }

    function insAcctRow(tbl_name)
    {
        var tbl = document.getElementById(tbl_name);
        var new_row = tbl.rows[1].cloneNode(true);

        var inp1 = new_row.cells[1].getElementsByTagName('div')[0];
        var inp2 = new_row.cells[2].getElementsByTagName('div')[0];
        var inp3 = new_row.cells[3].getElementsByTagName('div')[0];
        var inp4 = new_row.cells[4].getElementsByTagName('div')[0];

        tbl.appendChild( new_row );
    }

    function delDocRow(tbl_name,row)
    {
        var cur_row = row.parentNode.parentNode.rowIndex;
        document.getElementById(tbl_name).deleteRow(cur_row);
    }

    function insDocRow(tbl_name)
    {
        var table = document.getElementById(tbl_name);
        var row = table.insertRow(1);

        var cell1 = row.insertCell(0);
        var cell2 = row.insertCell(1);
        var cell3 = row.insertCell(2);

        cell1.innerHTML = "<div id=\"devfile_file\"><input type=\"hidden\" id=\"devfile_file_id\" name=\"devfile_file_id[]\" value=\"\" /><input id=\"devfile_file\" type=\"file\" name=\"devfile_file[]\" /></div>";
        cell2.innerHTML = "<div id=\"devfile_details\"><input id=\"devfile_details\" type=\"text\" name=\"devfile_details[]\" value=\"\" /></div>";
        cell3.innerHTML = "<input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delDocbutton\" onclick=\"delDocRow('devdoc_table_tb',this)\" value=\"<?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_device_del_document', $lang); ?>\" />";
    }

    function delProcRow(tbl_name,row)
    {
        var cur_row = row.parentNode.parentNode.rowIndex;
        document.getElementById(tbl_name).deleteRow(cur_row);
    }

    function insProcRow(tbl_name)
    {
        var table = document.getElementById(tbl_name);
        var row = table.insertRow(1);

        var cell1 = row.insertCell(0);
        var cell2 = row.insertCell(1);
        var cell3 = row.insertCell(2);
        var cell4 = row.insertCell(3);
        var cell5 = row.insertCell(4);

        cell1.innerHTML = "<div id=\"devproc_acct\"><input id=\"devproc_acct\" type=\"text\" name=\"devproc_acct[]\" /></div>";
        cell2.innerHTML = "<div id=\"devproc_path\"><input id=\"devproc_path\" type=\"text\" name=\"devproc_path[]\" value=\"\" /></div>";
        cell3.innerHTML = "<div id=\"devproc_schedule\"><input id=\"devproc_schedule\" type=\"text\" name=\"devproc_schedule[]\" value=\"\" /></div>";
        cell4.innerHTML = "<div id=\"devproc_notes\"><textarea id=\"devproc_notes\" name=\"devproc_notes[]\"></textarea></div>";
        cell5.innerHTML = "<input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delProcbutton\" onclick=\"delProcRow('devproc_table_tb',this)\" value=\"<?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_device_del_process', $lang); ?>\" />";
    }

    function delICRow(tbl_name,row)
    {
        var cur_row = row.parentNode.parentNode.rowIndex;
        document.getElementById(tbl_name).deleteRow(cur_row);
    }

    function insICRow(tbl_name)
    {
        var tbl = document.getElementById(tbl_name);
        var new_row = tbl.rows[1].cloneNode(true);

        var inp1 = new_row.cells[1].getElementsByTagName('div')[0];
        var inp2 = new_row.cells[2].getElementsByTagName('div')[0];
        var inp3 = new_row.cells[3].getElementsByTagName('div')[0];
        var inp4 = new_row.cells[4].getElementsByTagName('div')[0];
        var inp5 = new_row.cells[4].getElementsByTagName('div')[0];

        tbl.appendChild( new_row );
    }

        $(function() {
            
            $(".kd_sbmt").click(function() {

                var form = $("#pwform").attr("class");
                var form_id = $(this).attr('id');
                var form_name = "pwform_"+form_id;

                var key_id = $("#key_id_"+form_id).val();
                var key_pwd = $("#key_pwd_"+form_id).val();
                var enc_key = $("#enc_key_"+form_id).val();
                
                var dataString = 'key_id='+ key_id + '&key_pwd=' + key_pwd + '&enc_key=' + enc_key;
                
                if(key_id == '' || key_pwd == '' || enc_key == '')
                {
                    $('.success').fadeOut(200).hide();
                    $('.error').fadeOut(200).show();
                }
                else
                {
                    $.ajax({
                        type: "POST",
                        dataType: "json",
                        url: "<?php echo WEB_ADDRESS; ?>ajax_pw_decode.php",
                        data: dataString,
                        success: function(data){

                            var dec_pw = data.pw;
                            if(dec_pw=='')
                            {
                                $('.success').fadeOut(200).hide();
                                $('.error').fadeOut(200).show();
                            }else{
                                $('.success').fadeIn(200).show();
                                $('.error').fadeOut(200).hide();
                                $("#kp_"+form_id).text(dec_pw);
                            }
                        }
                    });
                }
            return false;
            });
        });

        var progress = setInterval(function() {
            var $bar = $('.progress-bar');
            
            if ($bar.width()==400) {
                clearInterval(progress);
                $('.progress').removeClass('active');
            } else {
                $bar.width($bar.width()+100);
            }
            $bar.text($bar.width()/4 + "%");
        }, 800);
        
    </script>

</head>

