<?php
/*
*
* Copyright (c) 2014 AM Data Soft
* Distributed under the GNU GPL v3.
* License: http://www.gnu.org/licenses/gpl.html GPL version 3 or higher
*
*/

/*
*
* Purpose:         Provide session and support information. The only mandatory feature 
*                  is the "Sessions" tab where a user may chose to refresh their session data. 
*                  Feel free to add additional support related items to this page
* Developer:       AM Data Soft
* Version:         1.0
* Version date:    2014-04-10
*
*/

session_start();

require_once('settings.php');

date_default_timezone_set(DEFAULT_TIMEZONE);
define('SID', session_id());
define('CURRENT_PAGE', $_SERVER['SCRIPT_NAME']);
define('CURRENT_SCRIPT', $_SERVER['SCRIPT_FILENAME']);
define('CURRENT_URL',$_SERVER['REQUEST_URI']);

require_once(WEB_ROOT.'/lib/rest_client.php');
require_once(WEB_ROOT.'/incl/security.php');

$err_msg = "";

if($_GET['do'] == 'users_refresh' && $_GET['success'] != 'y'){
    if($_SESSION['user_data']['access_level'] == 'ADMIN' || $_SESSION['user_data']['access_level'] == 'MANAGER'){
        $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
        $rest_client = new rest_client($_SESSION['auth_head'],'');
        $users_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/user',json_encode($comp_id,true));
        $arr_users_list = json_decode($users_list_return, true);
        if(count($arr_users_list) > 0){
            $_SESSION['users_list'] = $arr_users_list;
            $_SESSION['users_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            header("location: ".CURRENT_PAGE."?do=users_refresh&success=y");
        }else{
            $err_msg = "";
        }
        
    }
}
if($_GET['do'] == 'devices_refresh' && $_GET['success'] != 'y'){
    $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
    $rest_client = new rest_client($_SESSION['auth_head'],'');
    $devices_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/devices',json_encode($comp_id,true));
    $arr_devicess_list = json_decode($devices_list_return, true);
    if(count($arr_devicess_list) > 0){
        $_SESSION['devices_list'] = $arr_devicess_list;
        $_SESSION['devices_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
        header("location: ".CURRENT_PAGE."?do=devices_refresh&success=y");
    }else{
        $err_msg = "";
    }
    
}
if($_GET['do'] == 'datacenters_refresh' && $_GET['success'] != 'y'){
    $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
    $rest_client = new rest_client($_SESSION['auth_head'],'');
    $datacenters_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/datacenters',json_encode($comp_id,true));
    $arr_datacenters_list = json_decode($datacenters_list_return, true);
    if(count($arr_datacenters_list) > 0){
        $_SESSION['datacenters_list'] = $arr_datacenters_list;
        $_SESSION['datacenters_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
        header("location: ".CURRENT_PAGE."?do=datacenters_refresh&success=y");
    }else{
        $err_msg = "";
    }
    
}
if($_GET['do'] == 'company_refresh' && $_GET['success'] != 'y'){
    $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
    $rest_client = new rest_client($_SESSION['auth_head'],'');
    $company_return = $rest_client->post(WEB_SERVICE_ADDRESS.'/company',json_encode($comp_id,true));
    $arr_co_return = json_decode($company_return, true);
    if(count($arr_co_return) > 0){
        $_SESSION['company_data'] = $utilities_library->mk_array($arr_co_return['key'],$arr_co_return['property_list']);
        $_SESSION['company_data_create_dt'] = gmdate("Y-m-d H:i:s", time());
        header("location: ".CURRENT_PAGE."?do=company_refresh&success=y");
    }else{
        $err_msg = "";
    }
    
}

require_once(WEB_ROOT.'/incl/top.php');

?>

<body>

<?php
require_once(WEB_ROOT.'/incl/head.php');
?>

    <div class="container">

    <h2 class="form-signin-heading"><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_pghead_info', DEFAULT_LANG); ?></h2>
    <?php
        if($err_msg != ''){
            print "<div class=\"alert alert-danger\"><b>".$formatting_library->make_lang_label($arr_labels, 'lbl_err_head', DEFAULT_LANG).":</b><br />".$err_message."</div>";
        }
    ?>
    <div class="tabbable">
        <ul class="nav nav-tabs">
            <?php 
                $pan1_active = "tab-pane active";
                $pan2_active = "tab-pane";
                $pan3_active = "tab-pane";
                if($_GET['do'] == 'users_refresh' || $_GET['do'] == 'devices_refresh' || $_GET['do'] == 'datacenters_refresh' || $_GET['do'] == 'company_refresh'){
                    $pan1_active = "tab-pane";
                    $pan2_active = "tab-pane active";
                    $pan3_active = "tab-pane";
            ?>
            <li><a href="#info_personal" data-toggle="tab"><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_about_you', DEFAULT_LANG); ?></a></li>
            <li class="active"><a href="#info_sessions" data-toggle="tab"><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_about_sessions', DEFAULT_LANG); ?></a></li>
            <?php }else{ ?>
            <li class="active"><a href="#info_personal" data-toggle="tab"><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_about_you', DEFAULT_LANG); ?></a></li>
            <li><a href="#info_sessions" data-toggle="tab"><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_about_sessions', DEFAULT_LANG); ?></a></li>
            <?php } ?>
            <li><a href="#info_server" data-toggle="tab"><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_about_server', DEFAULT_LANG); ?></a></li>
        </ul>
        <div class="tab-content">
            <div class="<?php echo $pan1_active; ?>" id="info_personal">
                <br />
                <div class="row">
                    <div class="col-lg-10">
                        <table class="table table-striped">
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_username', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo $_SESSION['auth_head']['auth_head_user_name'] ;?></td>
                            </tr>
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_user_id', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo $_SESSION['user_data']['key'] ;?></td>
                            </tr>
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_session_id', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo session_id();?></td>
                            </tr>
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_browser', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo $_SERVER['HTTP_USER_AGENT'] ;?></td>
                            </tr>
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_ip', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo $_SERVER['REMOTE_ADDR'] ;?></td>
                            </tr>
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_connect_to', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo $_SERVER['SERVER_ADDR'].":".$_SERVER['REMOTE_PORT']." [".$_SERVER['REQUEST_SCHEME']." ".$_SERVER['REQUEST_METHOD']."]" ;?></td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
            <div class="<?php echo $pan2_active; ?>" id="info_sessions">
                <br />
                <div class="row">
                    <div class="col-lg-10">
                        <table class="table table-striped">
                            <?php if($_SESSION['user_data']['access_level'] == 'ADMIN' || $_SESSION['user_data']['access_level'] == 'MANAGER'){ ?>
                            <?php if ($_GET['do'] == 'users_refresh' && $err_msg == ''){ echo "<tr class=\"success\">";}else if($err_msg != ''){echo "<tr class=\"alert alert-danger\">"; }else{ echo "<tr>";} ?>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_pghead_users', DEFAULT_LANG); ?></strong></td>
                                <td><?php 
                                print "<form action=\"".CURRENT_PAGE."?do=users_refresh\" method=\"post\">";
                                if (isset($_SESSION['users_list'])){
                                    print "<button type=\"submit\" class=\"btn btn-default\" data-toggle=\"tooltip\" data-placement=\"left\" title=\"".$formatting_library->make_lang_label($arr_labels, 'lbl_info_last_updated', DEFAULT_LANG)." ".$utilities_library->mk_dt($_SESSION['users_list_create_dt'],'Y-m-d H:i:s',DATETIME_FORMAT)."\">".$formatting_library->make_lang_label($arr_labels, 'lbl_info_btn_reset', DEFAULT_LANG)."</button>";
                                }else{
                                    print "<button type=\"submit\" class=\"btn btn-default\">".$formatting_library->make_lang_label($arr_labels, 'lbl_info_btn_create', DEFAULT_LANG)."</button>";
                                }
                                print "</form>";
                                ?></td>
                            </tr>
                            <?php } ?>
                            <?php if ($_GET['do'] == 'devices_refresh' && $err_msg == ''){ echo "<tr class=\"success\">";}else if($err_msg != ''){echo "<tr class=\"alert alert-danger\">"; }else{ echo "<tr>";} ?>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_pghead_devices', DEFAULT_LANG); ?></strong></td>
                                <td><?php 
                                print "<form action=\"".CURRENT_PAGE."?do=devices_refresh\" method=\"post\">";
                                if (isset($_SESSION['devices_list'])){
                                    print "<button type=\"submit\" class=\"btn btn-default\" data-toggle=\"tooltip\" data-placement=\"left\" title=\"".$formatting_library->make_lang_label($arr_labels, 'lbl_info_last_updated', DEFAULT_LANG)." ".$utilities_library->mk_dt($_SESSION['devices_list_create_dt'],'Y-m-d H:i:s',DATETIME_FORMAT)."\">".$formatting_library->make_lang_label($arr_labels, 'lbl_info_btn_reset', DEFAULT_LANG)."</button>";
                                }else{
                                    print "<button type=\"submit\" class=\"btn btn-default\">".$formatting_library->make_lang_label($arr_labels, 'lbl_info_btn_create', DEFAULT_LANG)."</button>";
                                }
                                print "</form>";
                                ?></td>
                            </tr>
                            <?php if ($_GET['do'] == 'datacenters_refresh' && $err_msg == ''){ echo "<tr class=\"success\">";}else if($err_msg != ''){echo "<tr class=\"alert alert-danger\">"; }else{ echo "<tr>";} ?>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_pghead_datacenters', DEFAULT_LANG); ?></strong></td>
                                <td><?php 
                                print "<form action=\"".CURRENT_PAGE."?do=datacenters_refresh\" method=\"post\">";
                                if (isset($_SESSION['datacenters_list'])){
                                    print "<button type=\"submit\" class=\"btn btn-default\" data-toggle=\"tooltip\" data-placement=\"left\" title=\"".$formatting_library->make_lang_label($arr_labels, 'lbl_info_last_updated', DEFAULT_LANG)." ".$utilities_library->mk_dt($_SESSION['datacenters_list_create_dt'],'Y-m-d H:i:s',DATETIME_FORMAT)."\">".$formatting_library->make_lang_label($arr_labels, 'lbl_info_btn_reset', DEFAULT_LANG)."</button>";
                                }else{
                                    print "<button type=\"submit\" class=\"btn btn-default\">".$formatting_library->make_lang_label($arr_labels, 'lbl_info_btn_create', DEFAULT_LANG)."</button>";
                                }
                                print "</form>";
                                ?></td>
                            </tr>
                            <?php if ($_GET['do'] == 'company_refresh' && $err_msg == ''){ echo "<tr class=\"success\">";}else if($err_msg != ''){echo "<tr class=\"alert alert-danger\">"; }else{ echo "<tr>";} ?>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_pghead_company', DEFAULT_LANG); ?></strong></td>
                                <td><?php 
                                print "<form action=\"".CURRENT_PAGE."?do=company_refresh\" method=\"post\">";
                                if (isset($_SESSION['company_data'])){
                                    print "<button type=\"submit\" class=\"btn btn-default\" data-toggle=\"tooltip\" data-placement=\"left\" title=\"".$formatting_library->make_lang_label($arr_labels, 'lbl_info_last_updated', DEFAULT_LANG)." ".$utilities_library->mk_dt($_SESSION['company_data_create_dt'],'Y-m-d H:i:s',DATETIME_FORMAT)."\">".$formatting_library->make_lang_label($arr_labels, 'lbl_info_btn_reset', DEFAULT_LANG)."</button>";
                                }else{
                                    print "<button type=\"submit\" class=\"btn btn-default\">".$formatting_library->make_lang_label($arr_labels, 'lbl_info_btn_create', DEFAULT_LANG)."</button>";
                                }
                                print "</form>";
                                ?></td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
            <div class="<?php echo $pan3_active; ?>" id="info_server">
                <br />
                <div class="row">
                    <div class="col-lg-10">
                        <table class="table table-striped">
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_server_software', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo $_SERVER["SERVER_SOFTWARE"] ;?></td>
                            </tr>
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_server_admin', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo $_SERVER["SERVER_ADMIN"] ;?></td>
                            </tr>
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_server_host', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo $_SERVER["HTTP_HOST"]." [".$_SERVER["SERVER_ADDR"]."]";?></td>
                            </tr>
                            <tr>
                                <td><strong><?php echo $formatting_library->make_lang_label($arr_labels, 'lbl_info_engine_addr', DEFAULT_LANG); ?></strong></td>
                                <td><?php echo WEB_SERVICE_ADDRESS;?></td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>

<?php

require_once(WEB_ROOT.'/incl/bottom.php');

?>
