<?php
/*
*
* Copyright (c) 2014 AM Data Soft
* Distributed under the GNU GPL v3.
* License: http://www.gnu.org/licenses/gpl.html GPL version 3 or higher
*
*/

/*
*
* Purpose:         Classes for data formatting (forms and XML)
*                  DO NOT modify this file. Changing this file may void your support
* Developer:       AM Data Soft
* Version:         1.0
* Version date:    2014-04-10
*
*/


class formatting_library {
    
    function make_form($in_labels, $in_fields, $in_lang, $in_values = null, $in_submitted_value = null, $in_errors = null){
        $html_ret = "";
            foreach ($in_fields as $form_fields) {
                $html_ret .= "<div class=\"row\">";
                $current_field_name = $form_fields['field_name'];
                $is_error_field = false;
                if(isset($in_errors)){
                    foreach ($in_errors as $errors){
                        if($errors['field_name'] == $current_field_name){
                            $is_error_field = true;
                        }
                    }
                }
                $err_begin = "";
                $err_end = "";
                if($is_error_field == true){
                    $html_ret .= "<div class=\"form-group has-error\">";
                }else{
                    $html_ret .= "<div class=\"form-group\">";
                }

                $r_only = "";
                if($form_fields['field_readonly'] == true){
                    $r_only = " readonly";
                }
                $m_length = "";
                if($form_fields['field_length'] > 0){
                    $m_length = "maxlength=\"".$form_fields['field_length']."\"";
                }
                
                $def_value = "";
                if(isset($in_values[$form_fields['field_name']]) && !$in_submitted_value[$form_fields['field_name']]){
                    $def_value = $in_values[$form_fields['field_name']];
                }else if(!$in_values[$form_fields['field_name']] && isset($in_submitted_value[$form_fields['field_name']])){
                    $def_value = $in_submitted_value[$form_fields['field_name']];
                }else if(!$in_values[$form_fields['field_name']] && !isset($in_submitted_value[$form_fields['field_name']])){
                    $def_value = "";
                }else if(isset($in_values[$form_fields['field_name']]) && isset($in_submitted_value[$form_fields['field_name']])){
                    $def_value = $in_submitted_value[$form_fields['field_name']];
                }else if($is_error_field == true){
                    $def_value = $in_values[$form_fields['field_name']];
                }
                
                $f_value = "";
                $txt_value = "";
                if(isset($def_value) && $def_value != "" ){
                    $f_value = " value=\"".$def_value."\"";
                    $txt_value = $def_value;
                }
                $lbl_name = $form_fields['field_label'];
                $html_ret .= "<label for=\"".$form_fields['field_name']."\" class=\"col-lg-4 control-label\">".formatting_library::make_lang_label($in_labels,$lbl_name,$in_lang)."</label>";
                
                if($form_fields['field_type'] == 'password'){
                    $html_ret .= "<div class=\"col-lg-6\"><input type=\"password\" class=\"form-control\" id=\"".$form_fields['field_name']."\" name=\"".$form_fields['field_name']."\" ".$m_length." ".$r_only." ".$f_value."></div>";
                }else if($form_fields['field_type'] == 'select'){
                    $html_ret .= "<div class=\"col-lg-6\"><select class=\"form-control\" id=\"".$form_fields['field_name']."\" name=\"".$form_fields['field_name']."\">";
                    // we expect teh value to be an array, so let's check for it
                    if(is_array($form_fields['field_default_val'])){
                        foreach ($form_fields['field_default_val'] as $field_option_key => $field_option_value) {
                            if($field_option_key == $def_value){
                                $html_ret .= "<option value=\"".$field_option_key."\" selected>".$field_option_value."</option>";
                            }else{
                                $html_ret .= "<option value=\"".$field_option_key."\">".$field_option_value."</option>";
                            }
                        }
                    }else{
                        $html_ret .= "<option value=\"".$def_value."\" selected>".$def_value."</option>";
                    }
                    $html_ret .= "</select></div>";
                }else if($form_fields['field_type'] == 'file'){
                    $html_ret .= "<div class=\"col-lg-6\"><input type=\"file\" class=\"form-control\" id=\"".$form_fields['field_name']."\" name=\"".$form_fields['field_name']."\"></div>";
                }else if($form_fields['field_type'] == 'textarea'){
                    $html_ret .= "<div class=\"col-lg-6\"><textarea class=\"form-control\" id=\"".$form_fields['field_name']."\" name=\"".$form_fields['field_name']."\">".base64_decode($txt_value)."</textarea></div>";
                }else{
                    $html_ret .= "<div class=\"col-lg-6\"><input type=\"text\" class=\"form-control\" id=\"".$form_fields['field_name']."\" name=\"".$form_fields['field_name']."\" ".$m_length." ".$r_only." ".$f_value."></div>";
                }
                $html_ret .= "</div></div>";
            }
            
        
        $html_ret .= "";
        return $html_ret;
    }
    
    function make_simple_xhtml_form($in_labels, $field, $in_lang, $in_value = null, $in_submitted_value = null, $in_errors = null){
        
        $input_arr = [];

        $input_readonly = [];
        $input_maxlength = [];
        $input_class = [];
        $input_name = [];
        $input_value = [];
        $input_type = [];
        $input_id = [];

        $current_field_name = $field['field_name'];
        $is_error_field = false;
        if(isset($in_errors)){
            foreach ($in_errors as $errors){
                if($errors['field_name'] == $current_field_name){
                    $is_error_field = true;
                }
            }
        }
        if($is_error_field == true){
            $input_class = ['attribute' => 'class', 'value' => 'form-control has-error'];
        }else{
            $input_class = ['attribute' => 'class', 'value' => 'form-control'];
        }
        if($field['field_readonly'] == true){
            $input_readonly = ['attribute' => 'readonly', 'value' => 'readonly'];
        }
        if($field['field_length'] > 0){
            $input_maxlength = ['attribute' => 'maxlength', 'value' => $field['field_length']];
        }

        if(isset($in_value) && !$in_submitted_value[$field['field_name']]){
            $input_value = ['attribute' => 'value', 'value' => $in_value];
        }else if(!$in_value && isset($in_submitted_value[$field['field_name']])){
            $input_value = ['attribute' => 'value', 'value' => $in_submitted_value[$field['field_name']]];
        }else if(!$in_value && !isset($in_submitted_value[$field['field_name']])){
            $input_value = ['attribute' => 'value', 'value' => ''];
        }else if(isset($in_value) && isset($in_submitted_value[$field['field_name']])){
            $input_value = ['attribute' => 'value', 'value' => $in_submitted_value[$field['field_name']]];
        }else if($is_error_field == true){
            $input_value = ['attribute' => 'value', 'value' => $in_value];
        }

        $input_id = ['attribute' => 'id', 'value' => $field['field_name']];
        $input_name = ['attribute' => 'name', 'value' => $field['field_name']];

        if($field['field_type'] == 'password'){
            $input_arr = ['element'=>'input'];
            $input_type = ['attribute' => 'type', 'value' => 'text'];
        }else if($field['field_type'] == 'select'){
            $input_arr = ['element'=>'select'];
            $input_type = ['attribute' => 'type', 'value' => 'select'];
            $select_source = [];
            if($field['field_default_val'] == 'datacenters_list'){
                $select_source = utilities_library::select_datacenters_ds(false,false);
            }else if($field['field_default_val'] == 'users_list'){
                $select_source = utilities_library::select_users_ds(false,false);
            }else if(is_array($field['field_default_val'])){
                $select_source = $field['field_default_val'];
            }else{
                $select_source = null;
            }
            $input_value = ['attribute' => 'value', 'value' => $select_source];
        }else if($field['field_type'] == 'file'){
            $input_arr = ['element'=>'input'];
            // we don't allow file uploads in templates
            $input_type = ['attribute' => 'type', 'value' => 'text'];
        }else if($field['field_type'] == 'any'){
            $input_arr = ['element'=>'input'];
            $input_type = ['attribute' => 'type', 'value' => 'text'];
        }else if($field['field_type'] == 'textarea'){
            $input_arr = ['element'=>'textarea'];
            $input_type = ['attribute' => 'type', 'value' => 'textarea'];
        }else{
            $input_arr = ['element'=>'input'];
            $input_type = ['attribute' => 'type', 'value' => 'text'];
        }

        $input_arr[0] = $input_type;
        $input_arr[1] = $input_id;
        $input_arr[2] = $input_name;
        $input_arr[3] = $input_value;
        $input_arr[4] = $input_class;
        $input_arr[5] = $input_maxlength;
        $input_arr[6] = $input_readonly;

        return $input_arr;
    }

    function rack_types(){
        $arr_rt = ['Server','Cabinet','Storage','Network','Spacer'];
        return $arr_rt;
    }

    function make_rac_form($arr_labels, $lang, $dc_data){

        $arr_rt = formatting_library::rack_types();

        $html_ret = "<div id=\"rack_table_k\">";
        $html_ret .= "<input type=\"button\" class=\"btn btn-success btn-group-sm\" id=\"newRackbutton\" onclick=\"insRow('rack_table_tb')\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_add_rack', $lang)."\" />";
        $html_ret .= "<table id=\"rack_table_tb\" class=\"table table-striped\">";
        $html_ret .= "<tr>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_rack_type', $lang)."</th>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_rack_row', $lang)."</th>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_rack_num', $lang)."</th>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_rack_label', $lang)."</th>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_rack_u_size', $lang)."</th>";
        $html_ret .= "<th>&nbsp;</th>";
        $html_ret .= "</tr>";

        $rack_data = utilities_library::make_racks_array_from_dc($dc_data,'rack_num',false);
        if($rack_data['racks_count'] > 0){
            foreach ($rack_data['racks']  as $rack_row){
                foreach ($rack_row  as $rack_label){
                    if(isset($rack_label['rack_type']) && $rack_label['rack_type'] != ''){
                        $html_ret .= "<tr>";
                        $html_ret .= "<td><div id=\"rack_type\">";
                        $html_ret .= "<select name=\"rack_type[]\" id=\"rack_type\">";
                        foreach($arr_rt as $cab_type){
                            if($cab_type == $rack_label['rack_type']){
                                $html_ret .= "<option value=\"".$cab_type."\" selected>".$cab_type."</option>";
                            }else{
                                $html_ret .= "<option value=\"".$cab_type."\">".$cab_type."</option>";
                            }
                        }
                        $html_ret .= "</select>";
                        $html_ret .= "</div></td>";
                        $html_ret .= "<td><div id=\"rack_row\"><input type=\"text\" size=\"3\" name=\"rack_row[]\" value=\"".$rack_label['rack_row']."\" id=\"rack_row\"/></div></td>";
                        $html_ret .= "<td><div id=\"rack_num\"><input type=\"text\" size=\"3\" name=\"rack_num[]\" value=\"".$rack_label['rack_num']."\" id=\"rack_num\"/></div></td>";
                        $html_ret .= "<td><div id=\"rack_label\"><input type=\"text\" size=\"10\" name=\"rack_label[]\" value=\"".$rack_label['rack_label']."\" id=\"rack_label\"/></div></td>";
                        $html_ret .= "<td><div id=\"rack_size\"><input type=\"text\" size=\"5\" name=\"rack_size[]\" value=\"".$rack_label['rack_size']."\" id=\"rack_size\"/></div></td>";
                        $html_ret .= "<td>";
                        $html_ret .= "<input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delRackbutton\" onclick=\"delRow('rack_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_rem_rack', $lang)."\" />";
                        $html_ret .= "<input type=\"button\" class=\"btn btn-success btn-group-sm\" id=\"newRackbutton\" onclick=\"insRow('rack_table_tb')\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_add_rack', $lang)."\" />";
                        $html_ret .= "</td>";
                        $html_ret .= "</tr>";
                    }
                }
            }

        }else{
            $html_ret .= "<tr>";
            $html_ret .= "<td><div id=\"rack_type\">";
            $html_ret .= "<select name=\"rack_type[]\" id=\"rack_type\">";
            foreach($arr_rt as $cab_type){
                $html_ret .= "<option value=\"".$cab_type."\">".$cab_type."</option>";
            }
            $html_ret .= "</select>";
            $html_ret .= "</div></td>";
            $html_ret .= "<td><div id=\"rack_row\"><input type=\"text\" size=\"3\" name=\"rack_row[]\" value=\"A\" id=\"rack_row\"/></div></td>";
            $html_ret .= "<td><div id=\"rack_num\"><input type=\"text\" size=\"3\" name=\"rack_num[]\" value=\"1\" id=\"rack_num\"/></div></td>";
            $html_ret .= "<td><div id=\"rack_label\"><input type=\"text\" size=\"10\" name=\"rack_label[]\" value=\"A1\" id=\"rack_label\"/></div></td>";
            $html_ret .= "<td><div id=\"rack_size\"><input type=\"text\" size=\"5\" name=\"rack_size[]\" value=\"48\" id=\"rack_size\"/></div></td>";
            $html_ret .= "<td>";
            $html_ret .= "<input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delRackbutton\" onclick=\"delRow('rack_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_rem_rack', $lang)."\" />";
            $html_ret .= "<input type=\"button\" class=\"btn btn-success btn-group-sm\" id=\"newRackbutton\" onclick=\"insRow('rack_table_tb')\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_add_rack', $lang)."\" />";
            $html_ret .= "</td>";
            $html_ret .= "</tr>";
        }

        $html_ret .= "</table>";
        $html_ret .= "</div>";

        return $html_ret;
    }

    function make_iconnect_form($arr_labels, $lang, $dc_data, $dc_list_array){
        $html_ret = "<div id=\"dcic_table_k\">";
        $html_ret .= "<input type=\"button\" class=\"btn btn-success btn-group-sm\" id=\"newDCICbutton\" onclick=\"insRow('dcic_table_tb')\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_add_interconnect', $lang)."\" />";
        $html_ret .= "<table id=\"dcic_table_tb\" class=\"table table-striped\">";

        $html_ret .= "<tr>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_to_dc', $lang)."</th>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_net_speed', $lang)."</th>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_bandwidth', $lang)."</th>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_ic_provider', $lang)."</th>";
        $html_ret .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_dc_net_hops', $lang)."</th>";
        $html_ret .= "<th>&nbsp;</th>";
        $html_ret .= "</tr>";

        $iconn_data = utilities_library::make_iconn_array_from_dc($dc_data);

        if($dc_data['iconn_count'] > 0 && isset($dc_data['iconn_count'])){
            foreach($iconn_data as $iconn){
                $html_ret .= "<tr>";
                $html_ret .= "<td><div id=\"iconn_to\">";
                $html_ret .= "<select name=\"iconn_to[]\" id=\"iconn_to\">";
                foreach($dc_list_array as $dci){
                    if($dci['key'] != $dc_data['key']){
                        if($dci['key'] == $iconn['iconn_to']){
                            $html_ret .= "<option value=\"".$dci['key']."\" selected>".$dci['datacenter_name']."</option>";
                        }else{
                            $html_ret .= "<option value=\"".$dci['key']."\">".$dci['datacenter_name']."</option>";
                        }
                    }
                }
                
                $html_ret .= "</select>";
                $html_ret .= "</div></td>";
                $html_ret .= "<td><div id=\"rack_row\"><input type=\"text\" size=\"3\" name=\"iconn_speed[]\" value=\"".$iconn['iconn_speed']."\" id=\"iconn_speed\"/></div></td>";
                $html_ret .= "<td><div id=\"rack_num\"><input type=\"text\" size=\"3\" name=\"iconn_bandwidth[]\" value=\"".$iconn['iconn_bandwidth']."\" id=\"iconn_bandwidth\"/></div></td>";
                $html_ret .= "<td><div id=\"rack_label\"><input type=\"text\" size=\"10\" name=\"iconn_provider[]\" value=\"".$iconn['iconn_provider']."\" id=\"iconn_provider\"/></div></td>";
                $html_ret .= "<td><div id=\"rack_size\"><input type=\"text\" size=\"3\" name=\"iconn_hops[]\" value=\"".$iconn['iconn_hops']."\" id=\"iconn_hops\"/></div></td>";
                $html_ret .= "<td>";
                $html_ret .= "<input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delDCICbutton\" onclick=\"delRow('dcic_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_del_interconnect', $lang)."\" />";
                $html_ret .= "<input type=\"button\" class=\"btn btn-success btn-group-sm\" id=\"newDCICbutton\" onclick=\"insRow('dcic_table_tb')\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_add_interconnect', $lang)."\" />";
                $html_ret .= "</td>";
                $html_ret .= "</tr>";
            }
        }else{
        
            $html_ret .= "<tr>";
            $html_ret .= "<td><div id=\"iconn_to\">";
            $html_ret .= "<select name=\"iconn_to[]\" id=\"iconn_to\">";
            foreach($dc_list_array as $dci){
                if($dci['datacenter_name'] != $dc_data['datacenter_name']){
                    $html_ret .= "<option value=\"".$dci['key']."\">".$dci['datacenter_name']."</option>";
                }
            }
    
            $html_ret .= "</select>";
            $html_ret .= "</div></td>";
            $html_ret .= "<td><div id=\"rack_row\"><input type=\"text\" size=\"3\" name=\"iconn_speed[]\" value=\"\" id=\"iconn_speed\"/></div></td>";
            $html_ret .= "<td><div id=\"rack_num\"><input type=\"text\" size=\"3\" name=\"iconn_bandwidth[]\" value=\"\" id=\"iconn_bandwidth\"/></div></td>";
            $html_ret .= "<td><div id=\"rack_label\"><input type=\"text\" size=\"10\" name=\"iconn_provider[]\" value=\"\" id=\"iconn_provider\"/></div></td>";
            $html_ret .= "<td><div id=\"rack_size\"><input type=\"text\" size=\"3\" name=\"iconn_hops[]\" value=\"\" id=\"iconn_hops\"/></div></td>";
            $html_ret .= "<td>";
            $html_ret .= "<input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delDCICbutton\" onclick=\"delRow('dcic_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_del_interconnect', $lang)."\" />";
            $html_ret .= "<input type=\"button\" class=\"btn btn-success btn-group-sm\" id=\"newDCICbutton\" onclick=\"insRow('dcic_table_tb')\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_dc_add_interconnect', $lang)."\" />";
            $html_ret .= "</td>";
            $html_ret .= "</tr>";
        }
        
        $html_ret .= "</table>";
        $html_ret .= "</div>";
        return $html_ret;
    }

        function make_lang_label($in_labels, $in_label_name, $in_label_lang){
                $myret = "";
                $myret = gettext($in_label_name);
                if ($myret == $in_label_name || $myret == '' || $myret == null){
                    // we did not receive a translation
                    $domain = "infratrack";
                    $locale = "en_US.utf8";
                    putenv("LANG=".$locale);
                    setlocale(LC_MESSAGES, $locale);
                    bindtextdomain($domain, $directory);
                    textdomain($domain);
                    bind_textdomain_codeset($domain, 'UTF-8');
                    $myret = gettext($in_label_name);
                }
                return $myret;
        }

    
    function cmdbxsl_to_xhtml ($cmdb_xsl, $labels, $lang, $fields, $obj_data, $action = 'view'){
        $myret = "";
    
        $xmldoc = new DOMDocument("1.0", "utf-8");;
        $xmldoc->loadXML("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
        $xsldoc = new DOMDocument("1.0", "utf-8");;
        $xsldoc->formatOutput = true;
        $xsldoc->loadXML($cmdb_xsl);
        $xslproc = new XSLTProcessor;
    
        if($action != 'view' && $action != 'edit' && $action != 'preview'){
            $action = 'view';
        }
    
        for($c = 1; $a = $xsldoc->getElementsByTagName('label')->item(0); $c++) {
            $label_name = $a->nodeValue;
                        $label_value = formatting_library::make_lang_label($labels,$label_name,$lang);
            if($label_value != '' && isset($label_value)){
                $a->parentNode->replaceChild($xsldoc->createTextNode(sprintf($label_value, $c)),$a);
            }else{
                $a->parentNode->removeChild($a);
            }
        }
    
        for($c = 1; $a = $xsldoc->getElementsByTagName('field')->item(0); $c++) {
            $field_name = $a->nodeValue;
            // here we identify if the field is a form
            // or a value label
            if ($action == 'edit'){
                                # make form field
                $form_field_props = formatting_library::make_simple_xhtml_form($labels, $fields[$field_name], $lang, $obj_data[$field_name], null, null);
                $_frm_id = $form_field_props[1]['value'];
                $_frm_name = $form_field_props[2]['value'];
                $_frm_value = "N/A";
                if(isset($form_field_props[3]['value']) && $form_field_props[3]['value'] != null && $form_field_props[3]['value'] != ''){$_frm_value = $form_field_props[3]['value'];}
                $_frm_class = $form_field_props[4]['value'];
                $_frm_maxlen = $form_field_props[5]['value'];
                $_frm_ro = $form_field_props[6]['value'];

                if($form_field_props['element'] == 'textarea'){
                    // textarea is handled as a HTML object
                    $frag_txt = $xsldoc->createDocumentFragment();
                    $textarea_value = $_frm_value;
                    if (base64_decode($_frm_value) == True && $_frm_value != 'N/A'){
                        $textarea_value = base64_decode($_frm_value);
                    }
                    $textarea_html = "<textarea name=\"".$_frm_name."\" id=\"".$_frm_id."\" class=\"".$_frm_class."\" maxlength=\"".$_frm_maxlen."\">".$textarea_value."</textarea>";

                    $frag_txt->appendXML($textarea_html);
                    $a->parentNode->replaceChild($frag_txt,$a);
                }else if($form_field_props['element'] == 'select'){
                    // select is handled as a HTML object
                    // default selected value
                    $sel_value = $obj_data[$_frm_name];
                    $frag_select = $xsldoc->createDocumentFragment();
                    $select_html = "<select name=\"".$_frm_name."\" id=\"".$_frm_id."\" class=\"".$_frm_class."\">";
                    foreach($_frm_value as $k=>$v){
                        if ($sel_value == $k){
                            $select_html .= "<option value=\"".$k."\" selected=\"selected\">".$v."</option>";
                        }else{
                            $select_html .= "<option value=\"".$k."\">".$v."</option>";
                        }
                    }
                    $select_html .= "</select>";
                    $frag_select->appendXML($select_html);
                    $a->parentNode->replaceChild($frag_select,$a);
                }else{
                    $field_data = $xsldoc->createElement($form_field_props['element']);
                    foreach($form_field_props as $fp){
                        if(isset($fp['attribute']) && $fp['attribute'] != ''){
                            $field_data->setAttribute($fp['attribute'], $fp['value']);
                        }
                    }
                    $xsldoc->appendChild($field_data);
                    $a->parentNode->replaceChild($field_data,$a);
                }
            }else if ($action == 'preview'){
                $a->parentNode->replaceChild($xsldoc->createTextNode(sprintf('var', $c)),$a);
            }else{
                $form_field_props = formatting_library::make_simple_xhtml_form($labels, $fields[$field_name], $lang, $obj_data[$field_name], null, null);
                if($form_field_props['element'] == 'textarea'){
                    $_frm_value = "N/A";
                    if(isset($form_field_props[3]['value']) && $form_field_props[3]['value'] != null && $form_field_props[3]['value'] != ''){$_frm_value = $form_field_props[3]['value'];}
                    $text_value = $_frm_value;
                    if (base64_decode($_frm_value) == True && $_frm_value != 'N/A'){
                        $text_value = base64_decode($_frm_value);
                    }
                    $a->parentNode->replaceChild($xsldoc->createTextNode(sprintf($text_value, $c)),$a);
                }else if($form_field_props['element'] == 'select'){
                    $_frm_name = $form_field_props[2]['value'];
                    $sel_value = $obj_data[$_frm_name];
                    $_frm_value = "N/A";
                    if(isset($form_field_props[3]['value']) && $form_field_props[3]['value'] != null && $form_field_props[3]['value'] != ''){$_frm_value = $form_field_props[3]['value'];}
                    $sel_val_txt = "";
                    foreach($_frm_value as $k=>$v){
                        if ($sel_value == $k){
                            $sel_val_txt = $v;
                        }
                    }
                    $a->parentNode->replaceChild($xsldoc->createTextNode(sprintf($sel_val_txt, $c)),$a);
                }else{
                    $a->parentNode->replaceChild($xsldoc->createTextNode(sprintf($obj_data[$field_name], $c)),$a);
                }
            }
        }

        $xslproc->importStyleSheet($xsldoc);
        $myret = $xslproc->transformToXML($xmldoc);
    
        return $myret;
    }
    
}

$formatting_library = new formatting_library();

?>
