<?php
/*
*
* Copyright (c) 2014 AM Data Soft
* Distributed under the GNU GPL v3.
* License: http://www.gnu.org/licenses/gpl.html GPL version 3 or higher
*
*/

/*
*
* Purpose:         API client for REST CURL communication and data transfer
*                  DO NOT modify this file
* Developer:       AM Data Soft
* Version:         1.0
* Version date:    2014-04-10
*
*/


class rest_client {

    var $headers;
    var $user_agent;
    var $proxy;

    function rest_client($user_login,$proxy='') {
        $this->headers[] = "Accept: application/json";
        $this->headers[] = "Connection: Keep-Alive";
        $this->headers[] = "Content-type: application/json";
        $this->headers[] = "auth_head_user_name: ".$user_login['auth_head_user_name']."";
        $this->headers[] = "auth_head_password: ".$user_login['auth_head_password']."";
        $this->headers[] = "auth_head_company_id: ".$user_login['auth_head_company_id']."";
        $this->user_agent = "DovenestClient";
        $this->proxy=$proxy;
    }

    /*
    function get($url) {
        $process = curl_init($url);
        curl_setopt($process, CURLOPT_HTTPHEADER, $this->headers);
        //curl_setopt($process, CURLOPT_HEADER, 0);
        curl_setopt($process, CURLOPT_TIMEOUT, 30);
        if ($this->proxy) curl_setopt($process, CURLOPT_PROXY, $this->proxy);
        curl_setopt($process, CURLOPT_POSTFIELDS, $data);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        #curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($process, CURLOPT_CUSTOMREQUEST, "GET");
        $return = curl_exec($process);
        curl_close($process);
        return $return;
    }
    */

    function get($url,$data) {
        $process = curl_init($url);
        curl_setopt($process, CURLOPT_HTTPHEADER, $this->headers);
        //curl_setopt($process, CURLOPT_HEADER, 1);
        curl_setopt($process, CURLOPT_TIMEOUT, 30);
        if ($this->proxy) curl_setopt($process, CURLOPT_PROXY, $this->proxy);
        curl_setopt($process, CURLOPT_POSTFIELDS, $data);
        //curl_setopt($process, CURLOPT_VERBOSE, TRUE);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        //curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        //curl_setopt($process, CURLOPT_POST, 1);
        curl_setopt($process, CURLOPT_CUSTOMREQUEST, "GET");
        $return = curl_exec($process);
        curl_close($process);
        return $return;
    }
    
    
    function post($url,$data) {
        $process = curl_init($url);
        curl_setopt($process, CURLOPT_HTTPHEADER, $this->headers);
        //curl_setopt($process, CURLOPT_HEADER, 1);
        curl_setopt($process, CURLOPT_TIMEOUT, 30);
        if ($this->proxy) curl_setopt($process, CURLOPT_PROXY, $this->proxy);
        curl_setopt($process, CURLOPT_POSTFIELDS, $data);
        //curl_setopt($process, CURLOPT_VERBOSE, TRUE);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        //curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        //curl_setopt($process, CURLOPT_POST, 1);
        curl_setopt($process, CURLOPT_CUSTOMREQUEST, "POST");
        $return = curl_exec($process);
        curl_close($process);
        return $return;
    }

    function put($url,$data) {
        $process = curl_init($url);
        //$this->headers[] = "X-HTTP-Method-Override: PUT";
        curl_setopt($process, CURLOPT_HTTPHEADER, $this->headers);
        //curl_setopt($process, CURLOPT_HEADER, 1);
        curl_setopt($process, CURLOPT_TIMEOUT, 30);
        if ($this->proxy) curl_setopt($process, CURLOPT_PROXY, $this->proxy);
        curl_setopt($process, CURLOPT_POSTFIELDS, $data);
        //curl_setopt($process, CURLOPT_VERBOSE, TRUE);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        //curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($process, CURLOPT_CUSTOMREQUEST, "PUT");
        $return = curl_exec($process);
        curl_close($process);
        return $return;
    }

    function delete($url,$data) {
        $process = curl_init($url);
        curl_setopt($process, CURLOPT_HTTPHEADER, $this->headers);
        //curl_setopt($process, CURLOPT_HEADER, 1);
        curl_setopt($process, CURLOPT_TIMEOUT, 30);
        if ($this->proxy) curl_setopt($process, CURLOPT_PROXY, $this->proxy);
        curl_setopt($process, CURLOPT_POSTFIELDS, $data);
        //curl_setopt($process, CURLOPT_VERBOSE, TRUE);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        //curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($process, CURLOPT_CUSTOMREQUEST, "DELETE");
        $return = curl_exec($process);
        curl_close($process);
        return $return;
    }

    function listobj($url,$data) {
        $process = curl_init($url);
        curl_setopt($process, CURLOPT_HTTPHEADER, $this->headers);
        //curl_setopt($process, CURLOPT_HEADER, 1);
        curl_setopt($process, CURLOPT_TIMEOUT, 30);
        if ($this->proxy) curl_setopt($process, CURLOPT_PROXY, $this->proxy);
        curl_setopt($process, CURLOPT_POSTFIELDS, $data);
        //curl_setopt($process, CURLOPT_VERBOSE, TRUE);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        //curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($process, CURLOPT_CUSTOMREQUEST, "LIST");
        $return = curl_exec($process);
        curl_close($process);
        return $return;
    }

    function sum($url,$data) {
        $process = curl_init($url);
        curl_setopt($process, CURLOPT_HTTPHEADER, $this->headers);
        //curl_setopt($process, CURLOPT_HEADER, 1);
        curl_setopt($process, CURLOPT_TIMEOUT, 30);
        if ($this->proxy) curl_setopt($process, CURLOPT_PROXY, $this->proxy);
        curl_setopt($process, CURLOPT_POSTFIELDS, $data);
        //curl_setopt($process, CURLOPT_VERBOSE, TRUE);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        //curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($process, CURLOPT_CUSTOMREQUEST, "SUM");
        $return = curl_exec($process);
        curl_close($process);
        return $return;
    }
    
}

?>
