<?php
/*
*
* Copyright (c) 2014 AM Data Soft
* Distributed under the GNU GPL v3.
* License: http://www.gnu.org/licenses/gpl.html GPL version 3 or higher
*
*/

/*
*
* Purpose:         Application utilities
*                  DO NOT modify this file. Changing this file may void your support
* Developer:       AM Data Soft
* Version:         1.0
* Version date:    2014-04-10
*
*/


class property_list {
    public $prop_name;
    public $prop_value;
}

class utilities_library {
    
    function mk_array($id, $arr_of_properties){
        $ret = [];
        $ret = ['key' => $id]+$ret;
        foreach ($arr_of_properties as $prop_list) {
            $ret = [$prop_list['prop_name'] => $prop_list['prop_value']]+$ret;
        }
        
        return $ret;
    }
    
    function mk_json_props_array($in_key,$cur_vars,$in_arr){
        $arr_submit = [];
        // process existing values
        foreach ($cur_vars as $arr_key => $arr_val) {
            if(array_key_exists($arr_key,$in_arr)){
                $arr_submit = [$arr_key => $in_arr[$arr_key]]+$arr_submit;
            }else{
                if($arr_key == 'key'){
                }else if($arr_key == 'company_id'){
                    $arr_submit = [$arr_key => $arr_val]+$arr_submit;
                }else if($arr_key == 'active_yn'){
                    $arr_submit = [$arr_key => $arr_val]+$arr_submit;
                }else{
                    /*
                    any of those keys belong to older form fields
                    and probably should be kept in the database 
                    unfortunately they are invisible so we 
                    skip them
                    */
                    
                    // $arr_submit = [$arr_key => $arr_val]+$arr_submit;
                }
            }
        }
        // process new_values
        foreach ($in_arr as $arr_key => $arr_val) {
            if(!array_key_exists($arr_key,$cur_vars)){
                // new value, add to array
                $arr_submit = [$arr_key => $arr_val]+$arr_submit;
            }
        }

        // remove some keys which are assigned by default
        unset($arr_submit['created_by']);
        unset($arr_submit['created_on']);
        unset($arr_submit['modified_by']);
        unset($arr_submit['modified_on']);
        
        
        foreach ($arr_submit as $arr_key => $arr_val) {
            $i++;
            if($arr_key != '' && $arr_val != ''){
                $myarr = ['prop_name' => $arr_key, 'prop_value' => $arr_val];
                $arr_of_props[] = $myarr;
            }
        }
        
        $ret = ['key' => $in_key, 'property_list' => $arr_of_props];

        return $ret;
    }
    
    function mk_dt($in_utc_date, $dt_input_format = null, $dt_exit_format = null){
        $myret = "";
        if($dt_input_format == null){
            $dt_format = "Y-m-d H:i:s.u";
        }
        if($dt_format == null){
            $dt_format = "Y-m-d H:i:s T";
        }

        $clean_utc_date = explode('.',$in_utc_date);
        $date_utc = DateTime::createFromFormat("Y-m-d H:i:s", $clean_utc_date[0], new DateTimeZone('UTC'));
        $myret = "".date($dt_exit_format,$date_utc->format('U'))."";


        return $myret;
    }
    
    function form_fields_validation($in_form_fields, $in_form_values){
        $ret = [];
        
        $phone_regex = '/^(?:1(?:[. -])?)?(?:\((?=\d{3}\)))?([2-9]\d{2})'
        .'(?:(?<=\(\d{3})\))? ?(?:(?<=\d{3})[.-])?([2-9]\d{2})'
        .'[. -]?(\d{4})(?: (?i:ext)\.? ?(\d{1,5}))?$/';

        foreach ($in_form_fields as $field_groups) {
            foreach ($field_groups as $field_details) {
                if($field_details['field_validate'] == true){
                    $i++;
                    // we must validate the field
                    $field_value = str_replace(' ','',$in_form_values[$field_details['field_name']]);
                    $field_type = $field_details['field_type'];
                    $field_name = $field_details['field_name'];
                    $field_validate = $field_details['field_validate'];
                    $myarr = [];
                    
                    // check for email
                    if($field_type == 'email' && !filter_var($field_value, FILTER_VALIDATE_EMAIL)){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_email',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    // check phone format
                    }else if($field_type == 'phone' && !preg_match($phone_regex, $field_value)){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_phone',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    // check alpha numeric
                    }else if($field_type == 'alphanum' && ctype_alnum($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_string',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    // check numeric
                    }else if($field_type == 'num' && is_numeric($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_number',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    // check alpha
                    }else if($field_type == 'alpha' && ctype_alpha($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_alpha',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    // check int
                    }else if($field_type == 'int' && is_int($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_int',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    // check boolean
                    }else if($field_type == 'bool' && is_bool($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_bool',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    }else if($field_type == 'any' && $field_validate == true && $field_value == ''){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_string',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    }else if($field_value == ''){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_string',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    }
                    if($myarr != null){
                        $arr_of_errors[] = $myarr;
                    }
                }
            }
        }

        $ret = $arr_of_errors;

        return $ret;
    }
    
    function template_form_fields_validation($in_form_fields, $in_form_values){
        $ret = [];
        
        $phone_regex = '/^(?:1(?:[. -])?)?(?:\((?=\d{3}\)))?([2-9]\d{2})'
        .'(?:(?<=\(\d{3})\))? ?(?:(?<=\d{3})[.-])?([2-9]\d{2})'
        .'[. -]?(\d{4})(?: (?i:ext)\.? ?(\d{1,5}))?$/';
        
        //foreach ($in_form_fields as $field_groups) {
            foreach ($in_form_fields as $field_details) {
                if($field_details['field_validate'] == true && isset($in_form_values[$field_details['field_name']])){
                    $i++;
                    // we must validate the field
                    $field_value = str_replace(' ','',$in_form_values[$field_details['field_name']]);
                    $field_type = $field_details['field_type'];
                    $field_name = $field_details['field_name'];
                    $field_validate = $field_details['field_validate'];
                    $myarr = [];
                        
                    // check for email
                    if($field_type == 'email' && !filter_var($field_value, FILTER_VALIDATE_EMAIL)){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_email',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                        // check phone format
                    }else if($field_type == 'phone' && !preg_match($phone_regex, $field_value)){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_phone',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                        // check alpha numeric
                    }else if($field_type == 'alphanum' && ctype_alnum($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_string',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                        // check numeric
                    }else if($field_type == 'num' && is_numeric($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_number',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                        // check alpha
                    }else if($field_type == 'alpha' && ctype_alpha($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_alpha',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                        // check int
                    }else if($field_type == 'int' && is_int($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_int',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                        // check boolean
                    }else if($field_type == 'bool' && is_bool($field_value) == false){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_bool',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    }else if($field_type == 'any' && $field_validate == true && $field_value == ''){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_string',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    }else if($field_value == ''){
                        $myarr = ['field_name' => $field_name, 'field_label' => formatting_library::make_lang_label(null,$field_details['field_label'],DEFAULT_LANG), 'field_error' => formatting_library::make_lang_label(null,'lbl_err_string',DEFAULT_LANG), 'field_value' => $in_form_values[$field_details['field_name']]];
                    }
        
                    if($myarr != null){
                        $arr_of_errors[] = $myarr;
                    }
                }
            //}
        }
        
        $ret = $arr_of_errors;
        
        return $ret;
    }
    
    
    function make_pagination($record_count, $current_index, $page, $arr_labels){
        $html_ret = "";
        
        // total number of pages
        $tot_pages = round($record_count/MAX_RECS_PER_PAGE, 0, PHP_ROUND_HALF_UP);
        if($tot_pages < $record_count/MAX_RECS_PER_PAGE){
            $tot_pages = $tot_pages + 1;
        }
        $how_far_from_end = $tot_pages-$current_index-1;

        $html_ret .= "<ul class=\"pagination pagination-sm\">";

        if($how_far_from_end == 0){
            // no next button
            $prev_pg_num = $current_index - 1;
            $html_ret .= "<li><a href=\"".$page."?pg=0\">".formatting_library::make_lang_label($arr_labels,'lbl_first',DEFAULT_LANG)."</a></li>";
            $html_ret .= "<li><a href=\"".$page."?pg=".$prev_pg_num."\">".formatting_library::make_lang_label($arr_labels,'lbl_previous',DEFAULT_LANG)."</a></li>";
        }else if($current_index == 0){
            // no previous button; we are on the first page
            $last_page = $tot_pages-1;
            $html_ret .= "<li><a href=\"".$page."?pg=1\">".formatting_library::make_lang_label($arr_labels,'lbl_next',DEFAULT_LANG)."</a></li>";
            $html_ret .= "<li><a href=\"".$page."?pg=".$last_page."\">".formatting_library::make_lang_label($arr_labels,'lbl_last',DEFAULT_LANG)."</a></li>";
        }else{
            $prev_pg_num = $current_index - 1;
            $next_pg_num = $current_index + 1;
            $last_page = $tot_pages-1;
            $html_ret .= "<li><a href=\"".$page."?pg=0\">".formatting_library::make_lang_label($arr_labels,'lbl_first',DEFAULT_LANG)."</a></li>";
            $html_ret .= "<li><a href=\"".$page."?pg=".$prev_pg_num."\">".formatting_library::make_lang_label($arr_labels,'lbl_previous',DEFAULT_LANG)."</a></li>";
            $html_ret .= "<li><a href=\"".$page."?pg=".$next_pg_num."\">".formatting_library::make_lang_label($arr_labels,'lbl_next',DEFAULT_LANG)."</a></li>";             
            $html_ret .= "<li><a href=\"".$page."?pg=".$last_page."\">".formatting_library::make_lang_label($arr_labels,'lbl_last',DEFAULT_LANG)."</a></li>";
        }
        $html_ret .= "</ul>";
        
        // let's display a list of pages in case the user wants to "jump"
        if($tot_pages > 5){
            $html_ret .= "<form action=\"#\" method=\"post\" enctype=\"multipart/form-data\" class=\"form-horizontal\"><div class=\"control-group\">";
            $html_ret .= "<label class=\"control-label\" for=\"inputPage\">".formatting_library::make_lang_label($arr_labels,'lbl_page',DEFAULT_LANG)."</label><div class=\"controls\"><select id=\"inputPage\" onchange=\"navigateTo(this, 'window', false);\" class=\"input-mini\">";
            for ($i = 0; $i < $tot_pages; $i++) {
                $j = $i + 1;
                if($current_index == $i){
                    $html_ret .= "<option value=\"".$page."?pg=".$i."\" selected>".$j."</option>";
                }else{
                    $html_ret .= "<option value=\"".$page."?pg=".$i."\">".$j."</option>";
                }
            }
            $html_ret .= "</select></div></form>";
        }
        
        return $html_ret;
    }
    
    function make_users_table($in_users_list,$in_cur_user, $lang, $cur_page, $start_rec, $end_rec, $arr_labels, $pgnum = 0){
        $html_ret = "";
        $i = 0;
        if($start_rec > count($in_users_list)){
            $start_rec = 0;
            $end_rec = $start_rec + MAX_RECS_PER_PAGE;
        }
        foreach ($in_users_list as $user_data) {
            if ($i >= $start_rec && $i < $end_rec){
                $arr_user = utilities_library::mk_array($user_data['key'],$user_data['property_list']);
                $html_ret .= "<tr>";
                $html_ret .= "<td>".$arr_user['user_name']."</td>";
                $html_ret .= "<td>".$arr_user['first_name']." ".$arr_user['last_name']."</td>";
                $html_ret .= "<td>".$arr_user['access_level']."</td>";
                $html_ret .= "<td>".utilities_library::mk_dt($arr_user['modified_on'],'Y-m-d H:i:s.u',DATETIME_FORMAT)."</td>";
                if($arr_user['active_yn'] == 'True'){
                    $html_ret .= "<td class=\"text-success\">".formatting_library::make_lang_label($arr_labels, 'lbl_active', $lang)."</td>";
                }else{
                    $html_ret .= "<td class=\"text-danger\">".formatting_library::make_lang_label($arr_labels, 'lbl_inactive', $lang)."</td>";
                }
                //href="#new_user" role="button" class="btn" data-toggle="modal"
                if($user_data['key'] == $in_cur_user['key']){
                    // user itself
                    $html_ret .= "<td><a href=\"profile.php\">".formatting_library::make_lang_label($arr_labels, 'lbl_edit', $lang)."</a></td>";
                //}else if($arr_user['access_level'] == 'ADMIN'){
                    // another admin
                    //$html_ret .= "<td><a href=\"#edit_user\" role=\"button\" data-toggle=\"modal\">Edit</a></td>";
                }else{
                    // all other users
                    if($arr_user['active_yn'] == 'True'){
                        $html_ret .= "<td><a href=\"".$cur_page."?uid=".$user_data['key']."&pg=".$pgnum."&do=edit_user\" role=\"button\" data-id=\"".$user_data['key']."\" data-toggle=\"modal\">".formatting_library::make_lang_label($arr_labels, 'lbl_edit', $lang)."</a> | <a href=\"".$cur_page."?uid=".$user_data['key']."&pg=".$pgnum."&do=deactivate\">".formatting_library::make_lang_label($arr_labels, 'lbl_deactivate', $lang)."</a></td>";
                    }else{
                        $html_ret .= "<td><a href=\"".$cur_page."?uid=".$user_data['key']."&pg=".$pgnum."&do=edit_user\" role=\"button\" data-id=\"".$user_data['key']."\" data-toggle=\"modal\">".formatting_library::make_lang_label($arr_labels, 'lbl_edit', $lang)."</a> | <a href=\"".$cur_page."?uid=".$user_data['key']."&pg=".$pgnum."&do=activate\">".formatting_library::make_lang_label($arr_labels, 'lbl_activate', $lang)."</a></td>";
                    }
                }
                $html_ret .= "</tr>";
            }
            $i++;
        }
        return $html_ret;
    }
    
    function make_dc_table($in_dc_list, $lang, $cur_page, $start_rec, $end_rec, $arr_labels, $pgnum = 0, $arr_dc_data_format, $full_dc_list){
        $html_ret = "";
        $i = 0;
        if($start_rec > count($in_dc_list)){
            $start_rec = 0;
            $end_rec = $start_rec + MAX_RECS_PER_PAGE;
        }
        foreach ($in_dc_list as $dc_data) {

            if ($i >= $start_rec && $i < $end_rec){

                $arr_dc = utilities_library::mk_array($dc_data['key'],$dc_data['property_list']);
                $html_ret .= "<tr>";
                $html_ret .= "<td>";
                $html_ret .= "<a href=\"#detailModal".$dc_data['key']."\" data-dcid=\"".$dc_data['key']."\" data-toggle=\"modal\">".$arr_dc['datacenter_name']."</a>";

                $html_ret .= "<!-- display dc modal section for ID ".$dc_data['key']." -->";
                $html_ret .= "<div class=\"modal fade\" id=\"detailModal".$dc_data['key']."\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myModalLabel\" aria-hidden=\"true\">";
                $html_ret .= "<div class=\"modal-dialog\">";
                $html_ret .= "<div class=\"modal-content\">";
                $html_ret .= "<div class=\"modal-header\">";
                $html_ret .= "<button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-hidden=\"true\">×</button>";
                $html_ret .= "<a href=\"#\" onclick=\"print_modal(document.getElementById('printable_modal_".$dc_data['key']."'));\">Print</a>";
                $html_ret .= "<h3 id=\"myModalLabel\">".$arr_dc['datacenter_name']."</h3>";
                $html_ret .= "</div>";
                $html_ret .= "<div class=\"modal-body\">";
                $html_ret .= "<div id=\"printable_modal_".$dc_data['key']."\">";
                $html_ret .= utilities_library::dc_info_modal($dc_data['property_list'],$lang,$arr_labels,$arr_dc_data_format, $dc_data['key'],$full_dc_list);
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "<!-- end display dc modal section for ID ".$dc_data['key']." -->";

                $html_ret .= "</td>";
                $html_ret .= "<td>".$arr_dc['datacenter_code']."</td>";
                $html_ret .= "<td>".utilities_library::mk_dt($arr_dc['modified_on'],'Y-m-d H:i:s.u',DATETIME_FORMAT)."</td>";
                if($arr_dc['active_yn'] == 'True'){
                    $html_ret .= "<td class=\"text-success\">".formatting_library::make_lang_label($arr_labels, 'lbl_active', $lang)."</td>";
                }else{
                    $html_ret .= "<td class=\"text-danger\">".formatting_library::make_lang_label($arr_labels, 'lbl_inactive', $lang)."</td>";
                }
                if($arr_dc['active_yn'] == 'True'){
                    $html_ret .= "<td><a href=\"".$cur_page."?dc_id=".$dc_data['key']."&pg=".$pgnum."&do=edit_dc\" role=\"button\" data-id=\"".$dc_data['key']."\" data-toggle=\"modal\">".formatting_library::make_lang_label($arr_labels, 'lbl_edit', $lang)."</a> | <a href=\"".$cur_page."?dc_id=".$dc_data['key']."&pg=".$pgnum."&do=deactivate\">".formatting_library::make_lang_label($arr_labels, 'lbl_deactivate', $lang)."</a></td>";
                }else{
                    $html_ret .= "<td><a href=\"".$cur_page."?dc_id=".$dc_data['key']."&pg=".$pgnum."&do=edit_dc\" role=\"button\" data-id=\"".$dc_data['key']."\" data-toggle=\"modal\">".formatting_library::make_lang_label($arr_labels, 'lbl_edit', $lang)."</a> | <a href=\"".$cur_page."?dc_id=".$dc_data['key']."&pg=".$pgnum."&do=activate\">".formatting_library::make_lang_label($arr_labels, 'lbl_activate', $lang)."</a></td>";
                }
                $html_ret .= "</tr>";
            }
            $i++;
        }
        return $html_ret;
    }
    
    function dc_info_modal($arr_dc,$lang,$arr_labels,$arr_dc_data_format, $dc_id, $dc_list){
        $html_ret = "";
        // items we don't want to display
        $arr_removed_objects = ['documents'];
        $arr_dc_data_format_filtered = $arr_dc_data_format;
        
        foreach($arr_removed_objects as $hidden_obj){
            unset($arr_dc_data_format_filtered[$hidden_obj]);
        }
        
        // generic section to show the labels
        $html_ret .= "<table class=\"table table-striped\">";
        foreach ($arr_dc_data_format_filtered as $dc_format){
            foreach ($dc_format as $dc_object){
                $label_value = utilities_library::map_obj_to_label($arr_dc,$lang,$arr_labels,$dc_object);
                if($label_value != '' && $label_value != null && isset($label_value)){
                    $html_ret .= "<tr>";
                    $html_ret .= "<td><strong>".$label_value['prop_name']."</strong></td>";
                    $html_ret .= "<td>".$label_value['prop_value']."</td>";
                    $html_ret .= "</tr>";
                }
            }
        }
        // we have a few "left over" items, like created time, last modified 
        // and people responsible, so we will show it here
        // lbl_created_on, lbl_created_by, lbl_last_modified, lbl_last_modified_by
        $arr_dc_data = utilities_library::mk_array($dc_id,$arr_dc);
        $rest_client = new rest_client($_SESSION['auth_head'],'');
        
        if (!isset($_SESSION['users_list'])){
            $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
            $rest_client = new rest_client($_SESSION['auth_head'],'');
            $users_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/user',json_encode($comp_id,true));
            $arr_users_list = json_decode($users_list_return, true);
            if(count($arr_users_list) > 0){
                $_SESSION['users_list'] = $arr_users_list;
                $_SESSION['users_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            }
        }
        
        // get the created_by user
        $created_by = "";
        // get the modified_by user
        $modified_by = "";
        foreach ($_SESSION['users_list']['item_list']  as $usr_data){
            $arr_user = utilities_library::mk_array($usr_data['key'],$usr_data['property_list']);
            if($usr_data['key'] == $arr_dc_data['created_by']){
                $created_by = "".$arr_user['first_name']." ".$arr_user['last_name']." [".$arr_user['user_name']."]";
            }
            if($usr_data['key'] == $arr_dc_data['modified_by']){
                $modified_by = "".$arr_user['first_name']." ".$arr_user['last_name']." [".$arr_user['user_name']."]";
            }
        }
        
        $html_ret .= "<tr>";
        $html_ret .= "<td><strong>".formatting_library::make_lang_label($arr_labels,'lbl_created_on',$lang)."</strong></td>";
        $html_ret .= "<td>".utilities_library::mk_dt($arr_dc_data['created_on'],'Y-m-d H:i:s.u',DATETIME_FORMAT)."</td>";
        $html_ret .= "</tr>";
        $html_ret .= "<tr>";
        $html_ret .= "<td><strong>".formatting_library::make_lang_label($arr_labels,'lbl_created_by',$lang)."</strong></td>";
        $html_ret .= "<td>".$created_by."</td>";
        $html_ret .= "</tr>";
        $html_ret .= "<tr>";
        $html_ret .= "<td><strong>".formatting_library::make_lang_label($arr_labels,'lbl_last_modified',$lang)."</strong></td>";
        $html_ret .= "<td>".utilities_library::mk_dt($arr_dc_data['modified_on'],'Y-m-d H:i:s.u',DATETIME_FORMAT)."</td>";
        $html_ret .= "</tr>";
        $html_ret .= "<tr>";
        $html_ret .= "<td><strong>".formatting_library::make_lang_label($arr_labels,'lbl_last_modified_by',$lang)."</strong></td>";
        $html_ret .= "<td>".$modified_by."</td>";
        $html_ret .= "</tr>";
        
        $html_ret .= "</table>";
        
        // section to show racks
        //$arr_dc2 = utilities_library::mk_array($dc_id,$arr_dc);
        if($arr_dc_data['racks_count'] > 0){
            $html_ret .= "<div class=\"panel panel-primary\">";
            $html_ret .= "<div class=\"panel-heading\">".formatting_library::make_lang_label($arr_labels,'lbl_dc_current_racks',$lang)."</div>";
            $html_ret .= "<div class=\"panel-body\">";
            $html_ret .= "<p>".formatting_library::make_lang_label($arr_labels,'lbl_dc_current_racks_desc',$lang)."</p>";
            $html_ret .= "</div>";
            $sort_col = 'rack_num';
            $html_ret .= utilities_library::make_racks_svg($arr_dc_data,$sort_col,false,$lang,$arr_labels);
            $html_ret .= "</div>";
        }else{
            $html_ret .= "<div class=\"panel panel-danger\">";
            $html_ret .= "<div class=\"panel-heading\">".formatting_library::make_lang_label($arr_labels,'lbl_dc_current_racks',$lang)."</div>";
            $html_ret .= "<div class=\"panel-body\">";
            $html_ret .= "<p>".formatting_library::make_lang_label($arr_labels,'lbl_dc_current_racks_no_desc',$lang)."</p>";
            $html_ret .= "</div>";
            $html_ret .= "</div>";
        }
        
        // section to show interconnects
        if(isset($arr_dc_data['iconn_count']) && $arr_dc_data['iconn_count']  > 0){
            $html_ret .= "<div class=\"panel panel-primary\">";
            $html_ret .= "<div class=\"panel-heading\">".formatting_library::make_lang_label($arr_labels,'lbl_dc_interconnects',$lang)."</div>";
            $html_ret .= "<div class=\"panel-body\">";
            $html_ret .= "<p>".formatting_library::make_lang_label($arr_labels,'lbl_dc_interconnects_desc',$lang)."</p>";
            $html_ret .= "</div>";
            $sort_col = 'rack_num';
            $html_ret .= utilities_library::make_dc_interconnect_svg($arr_dc_data,$lang,$arr_labels,$dc_list);
            $html_ret .= "</div>";
            }else{
                $html_ret .= "<div class=\"panel panel-danger\">";
                $html_ret .= "<div class=\"panel-heading\">".formatting_library::make_lang_label($arr_labels,'lbl_dc_interconnects',$lang)."</div>";
                $html_ret .= "<div class=\"panel-body\">";
                $html_ret .= "<p>".formatting_library::make_lang_label($arr_labels,'lbl_dc_interconnects_no_desc',$lang)."</p>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
        }

        // section to show the documents
        $filegroup = [
        'company_id' => $_SESSION['auth_head']['auth_head_company_id'],
        'file_class' => 'DATACENTER',
        'class_id' => $dc_id
        ];
        $arr_files_list = [];
        $files_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/files',json_encode($filegroup,true));
        if ((str_replace(' ','',$files_list_return['message']) != '' && $files_list_return['status'] > 300 && $files_list_return['status'] < 600) || (str_replace(' ','',$files_list_return['message']) != '' && $files_list_return['status'] > 300 && $files_list_return['status'] < 600)) {
            $html_ret .= $files_list_return['message'];
        }else{
        
            $arr_files_list = json_decode($files_list_return, true);
        
            if(count($arr_files_list['item_list']) > 0){

                $html_ret .= "<div class=\"panel panel-primary\">";
                $html_ret .= "<div class=\"panel-heading\">".formatting_library::make_lang_label($arr_labels,'lbl_dc_current_files',$lang)."</div>";
                $html_ret .= "<div class=\"panel-body\">";
                $html_ret .= "<p>".formatting_library::make_lang_label($arr_labels,'lbl_dc_current_files_desc',$lang)."</p>";
                $html_ret .= "</div>";
                
                $html_ret .= "<table class=\"table\">";
                
                foreach ($arr_files_list['item_list']  as $file_data){
                    $file_info = utilities_library::mk_array($file_data['key'],$file_data['property_list']);
                    # get the label for the current file:
                    $file_label = $arr_dc_data_format['documents'][$file_info['file_item']]['field_label'];
                     
                    $html_ret .= "<tr>";
                    $html_ret .= "<td valign=\"top\"><b>".formatting_library::make_lang_label($arr_labels,$file_label,$lang)."</b></td>";
                    $html_ret .= "<td valign=\"top\"><a href=\"getfile.php?file_id=".$file_info['key']."\">".$file_info['file_name']."</a><br />".$arr_dc_data[$file_info['file_item']."_details"]."</td>";
                    $html_ret .= "<td valign=\"top\">".$file_info['file_size']."b</td>";
                    $html_ret .= "<td valign=\"top\">".utilities_library::mk_dt($file_info['modified_on'],'Y-m-d H:i:s.u',DATETIME_FORMAT)."</td>";
                    $html_ret .= "</tr>";
                }
                
                $html_ret .= "</table>";
                $html_ret .= "</div>";
            }else{
                $html_ret .= "<div class=\"panel panel-danger\">";
                $html_ret .= "<div class=\"panel-heading\">".formatting_library::make_lang_label($arr_labels,'lbl_dc_current_files',$lang)."</div>";
                $html_ret .= "<div class=\"panel-body\">";
                $html_ret .= "<p>".formatting_library::make_lang_label($arr_labels,'lbl_dc_current_files_no_files',$lang)."</p>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
            }
        }

        return $html_ret;
    }
    
    function map_obj_to_label($dc_arr,$lang,$labels,$dc_objects){
        $myret = [];

        foreach($dc_arr as $obj_info){
            if(isset($obj_info['prop_name']) && $obj_info['prop_name'] != '' && $obj_info['prop_name'] == $dc_objects['field_name']){
                $myret .= "".$obj_info['prop_name']." = ".$obj_info['prop_value']."";
                $prop_name = formatting_library::make_lang_label($labels, $dc_objects['field_label'], $lang);
                $prop_value = $obj_info['prop_value'];
                $myret = ['prop_name' => $prop_name, 'prop_value' => $prop_value];
            }
        }
        return $myret;
    }
    
    function record_sort($records, $field, $reverse=false)
    {
        $hash = array();
        foreach($records as $record){
            $hash[$record[$field]] = $record;
        }
        ($reverse)? krsort($hash) : ksort($hash);
        $records = array();
        foreach($hash as $record){
            $records []= $record;
        }
        return $records;
    }
    
    function make_racks_array_from_dc($dc_data,$sort_col,$reverse=false){
        $rack_array = [];
        $high_rack = 0;
        $racks_count = 0;
        for ($x=1; $x<=$dc_data['racks_count']; $x++){
            if(isset($dc_data['rack_type_'.$x.'']) && $dc_data['rack_type_'.$x.''] != ''){
                $rack_array[$dc_data['rack_row_'.$x.'']][count($rack_array[$dc_data['rack_row_'.$x.'']])] = [
                    'rack_type' => $dc_data['rack_type_'.$x.''], 
                    'rack_size' => $dc_data['rack_size_'.$x.''], 
                    'rack_row' => $dc_data['rack_row_'.$x.''], 
                    'rack_num' => $dc_data['rack_num_'.$x.''], 
                    'rack_label' => $dc_data['rack_label_'.$x.'']
                ];
            }
        }
        $return_racks = [];
        foreach ($rack_array  as $rack_row){
            // sort by $sort_col
            $rack_row = utilities_library::record_sort($rack_row,$sort_col,$reverse);
            $k = 0;
            foreach ($rack_row  as $rack_data){
                $rack_num = $rack_data['rack_num'];
                if($rack_num >= $high_rack){
                    $high_rack = $rack_num;
                }
                $return_racks[$rack_data['rack_row']][$rack_data['rack_label']] = [
                    'rack_type' => $rack_data['rack_type'],
                    'rack_size' => $rack_data['rack_size'],
                    'rack_row' => $rack_data['rack_row'],
                    'rack_num' => $rack_data['rack_num'],
                    'rack_label' => $rack_data['rack_label']
                ];
                //var_dump($return_racks);
                //print "\n-----\n";
                $racks_count++;
                $k++;
            }
        }
        // a summary
        $rd = [];
        $rd['high_rack'] = $high_rack;
        $rd['racks_count'] = $racks_count;
        $rd['racks'] = $return_racks;

        return $rd;
    }
    
    function make_iconn_array_from_dc($dc_data){
        $iconn_array = [];
        for ($x=1; $x<=$dc_data['iconn_count']; $x++){
            if(isset($dc_data['iconn_to_'.$x.'']) && $dc_data['iconn_to_'.$x.''] != '' && $dc_data['active_yn'] == 'True'){
                if(
                    isset($dc_data['iconn_speed_'.$x.'']) && $dc_data['iconn_speed_'.$x.''] != '' &&
                    isset($dc_data['iconn_bandwidth_'.$x.'']) && $dc_data['iconn_bandwidth_'.$x.''] != '' &&
                    isset($dc_data['iconn_provider_'.$x.'']) && $dc_data['iconn_provider_'.$x.''] != '' &&
                    isset($dc_data['iconn_hops_'.$x.'']) && $dc_data['iconn_hops_'.$x.''] != ''
                        ){
                $iconn_array[$x] = [
                    'iconn_to' => $dc_data['iconn_to_'.$x.''],
                    'iconn_speed' => $dc_data['iconn_speed_'.$x.''],
                    'iconn_bandwidth' => $dc_data['iconn_bandwidth_'.$x.''],
                    'iconn_provider' => $dc_data['iconn_provider_'.$x.''],
                    'iconn_hops' => $dc_data['iconn_hops_'.$x.'']
                ];
                }
            }
        }
        return $iconn_array;
    }

    
    function make_accts_array_from_device($device_data){
        $accounts_array = [];
        for ($x=0; $x<=$device_data['accounts_count']; $x++){
            if(isset($device_data['devacct_account_'.$x.'']) && $device_data['devacct_account_type_'.$x.''] != '' && $device_data['devacct_account_key_'.$x.''] != '' && $device_data['active_yn'] == 'True'){
                if(
                    isset($device_data['devacct_account_'.$x.'']) && $device_data['devacct_account_'.$x.''] != '' &&
                    isset($device_data['devacct_account_type_'.$x.'']) && $device_data['devacct_account_type_'.$x.''] != '' &&
                    isset($device_data['devacct_account_key_'.$x.'']) && $device_data['devacct_account_key_'.$x.''] != '' 
                        ){
                $accounts_array[$x] = [
                    'devacct_account' => $device_data['devacct_account_'.$x.''],
                    'devacct_account_type' => $device_data['devacct_account_type_'.$x.''],
                    'devacct_account_pwd' => $device_data['devacct_account_pwd_'.$x.''],
                    'devacct_account_key' => $device_data['devacct_account_key_'.$x.'']
                ];
                }
            }
        }
        return $accounts_array;
    }
    
    
    function make_procs_array_from_device($device_data){
        $procs_array = [];
        for ($x=0; $x<=$device_data['processes_count']; $x++){
            if(isset($device_data['devproc_acct_'.$x.'']) && $device_data['devproc_path_'.$x.''] != '' && $device_data['devproc_schedule_'.$x.''] != '' && $device_data['active_yn'] == 'True'){
                if(
                        isset($device_data['devproc_acct_'.$x.'']) && $device_data['devproc_acct_'.$x.''] != '' &&
                        isset($device_data['devproc_path_'.$x.'']) && $device_data['devproc_path_'.$x.''] != '' &&
                        isset($device_data['devproc_schedule_'.$x.'']) && $device_data['devproc_schedule_'.$x.''] != ''
                ){
                    $procs_array[$x] = [
                    'devproc_acct' => $device_data['devproc_acct_'.$x.''],
                    'devproc_path' => $device_data['devproc_path_'.$x.''],
                    'devproc_schedule' => $device_data['devproc_schedule_'.$x.''],
                    'devproc_notes' => base64_decode($device_data['devproc_notes_'.$x.''])
                    ];
                }
            }
        }
        return $procs_array;
    }
    
    function make_interconnects_array_from_device($device_data){
        $ics_array = [];
        for ($x=0; $x<=$device_data['interconnects_count']; $x++){
            if(isset($device_data['devic_to_'.$x.'']) && $device_data['devic_port_'.$x.''] != '' && $device_data['active_yn'] == 'True'){
                if(
                        isset($device_data['devic_to_'.$x.'']) && $device_data['devic_to_'.$x.''] != '' &&
                        isset($device_data['devic_port_'.$x.'']) && $device_data['devic_port_'.$x.''] != ''
                ){
                    $ics_array[$x] = [
                    'devic_to' => $device_data['devic_to_'.$x.''],
                    'devic_protocol' => $device_data['devic_protocol_'.$x.''],
                    'devic_port' => $device_data['devic_port_'.$x.''],
                    'devic_notes' => base64_decode($device_data['devic_notes_'.$x.''])
                    ];
                }
            }
        }
        return $ics_array;
    }
    
    
    function make_racks_svg($dc_data,$sort_col,$reverse,$lang,$arr_labels){
        $racks = utilities_library::make_racks_array_from_dc($dc_data,$sort_col,$reverse);
        
        $html_ret = "";
        $svg_head = "";
        $html_ret2 = "";
        if(isset($racks['racks_count']) && $racks['racks_count'] > 0){

            $start_x = 15;
            $start_y = 10;
            $box_w = 30;
            $box_h = 30;
            $space_left = 3;
            $space_bottom = 10;
            $txt_y = 30;
            $font_size = "10 px";
            $bg_color = "rgb(118,170,237)";
        
            // loop the rack rows
            $j = 0;
            foreach ($racks['racks']  as $rack_row){
                for ($i=0; $i<=$racks['high_rack']; $i++){
                    $rack_type = '';
                    $rack_size = '';
                    $rack_rownum = '';
                    $rack_num = '';
                    $rack_lbl = '';
                    foreach ($rack_row  as $rack_label){
                        if($rack_label['rack_num'] == $i+1){
                            $rack_type = $rack_label['rack_type'];
                            $rack_size = $rack_label['rack_size'];
                            $rack_rownum = $rack_label['rack_row'];
                            $rack_num = $rack_label['rack_num'];
                            $rack_lbl = $rack_label['rack_label'];
                        }
                    }
                    $start_x2 = $start_x + ($box_w+$space_left)*$i;
                    $start_y2 = $start_y + ($box_h+$space_bottom)*$j;
                    $txt_x = $start_x2 + 15;
                    $txt_y2 = $txt_y + ($box_h+$space_bottom)*$j;
                    if($rack_type != ''){
                        // get the rack type
                        $arr_rt = formatting_library::rack_types();
                        if(in_array($rack_type,$arr_rt)){
                        }else{
                            $rack_type = 'Server';
                            $bg_color = "rgb(118,170,237)";
                        }
                        if($rack_type == 'Cabinet'){
                            $bg_color = "rgb(37,80,7)";
                        }
                        if($rack_type == 'Storage'){
                            $bg_color = "rgb(82,62,17)";
                        }
                        if($rack_type == 'Network'){
                            $bg_color = "rgb(133,0,0)";
                        }
                        if($rack_type == 'Server'){
                            $bg_color = "rgb(118,170,237)";
                        }
                        if($rack_type == 'Spacer'){
                            $html_ret .= "<rect x=\"".$start_x2."\" y=\"".$start_y2."\" rx=\"5\" ry=\"5\" width=\"".$box_w."\" height=\"".$box_h."\" style=\"fill:white\" />";
                        }else{
                            $html_ret .= "<rect x=\"".$start_x2."\" y=\"".$start_y2."\" rx=\"5\" ry=\"5\" width=\"".$box_w."\" height=\"".$box_h."\" style=\"fill:".$bg_color."\" />";
                            $html_ret .= "<text font-family=\"Helvetica\" font-weight=\"bold\" font-size=\"10px\" text-anchor=\"middle\" x=\"".$txt_x."\" y=\"".$txt_y2."\" fill=\"white\">";
                            $html_ret .= "".$rack_lbl."";
                            $html_ret .= "</text>";
                        }
                    }else{
                        $html_ret .= "<rect x=\"".$start_x2."\" y=\"".$start_y2."\" rx=\"0\" ry=\"0\" width=\"".$box_w."\" height=\"".$box_h."\" style=\"fill:white;\" />";
                    }
                }
                $j++;
            }
            
            $svg_w = $start_x + $box_w*$racks['high_rack'] + $space_left*$racks['high_rack'];
            $svg_h = $start_y + $box_h*$j + $space_bottom*$j;
            
            $svg_head .= "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"".$svg_w."\" height=\"".$svg_h."\" version=\"1.1\">";
            $svg_head .= "<rect x=\"10\" y=\"10\" width=\"".$svg_w."\" height=\"".$svg_h."\" style=\"fill:white\" />";

            $html_ret2 = $svg_head."".$html_ret."</svg>";
        }

        return $html_ret2;
    }
    
    function make_dc_interconnect_svg($dc_data,$lang,$arr_labels,$arr_dc){
        
        $iconns = utilities_library::make_iconn_array_from_dc($dc_data);
        $html_ret = "";
        
        if(isset($dc_data['iconn_count']) && $dc_data['iconn_count']  > 0){
        
            $dc_data2 = [];
            $k = 0;
            foreach ($arr_dc['item_list'] as $dc_info){
                $myarr = utilities_library::mk_array($dc_info['key'],$dc_info['property_list']);
                $dc_data2[$k] = $myarr;
                $k++;
            }

            $svg_height = count($iconns)*(50);
            $html_ret .= "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"500\" height=\"".$svg_height."\" version=\"1.1\">";
            $html_ret .= "<rect x=\"10\" y=\"10\" style=\"fill:white\" />";
        
            $start_x = 15;
            $start_y = 10;
            $box_w = 150;
            $box_h = 30;
            $space_left = 100;
            $space_bottom = 10;
            $txt_x = $start_x + ceil($box_w/2);;
            $txt_y = 30;
            $font_size = "10 px";
            $bg_color = "rgb(118,170,237)";
        
        
            # we loop once for lines
            $i = 0;
            foreach ($iconns  as $iconn){
                $start_x2 = $start_x + ($box_w+$space_left);
                $start_y2 = $start_y + ($box_h+$space_bottom)*$i;
                $txt_x2 = $start_x2 + ceil($box_w/2);
                $txt_y2 = $txt_y + ($box_h+$space_bottom)*$i;
                $mid_point_x1 = $start_x + $box_w/2;
                $mid_point_x2 = $start_x2 + $box_w/2;
                $mid_point_y1 = $start_y + $box_h/2;
                $mid_point_y2 = $start_y2 + $box_h/2;
                $dc_name = '';
                $dc_code = '';

                $html_ret .= "<line x1=\"".$mid_point_x1."\" y1=\"".$mid_point_y1."\" x2=\"".$mid_point_x2."\" y2=\"".$mid_point_y2."\" stroke-width=\"1\" stroke=\"black\"/>";
                $i++;
            }
        
            # and again for DC boxes so that they are on top of lines
            $j = 0;
            foreach ($iconns  as $iconn){
                $start_x2 = $start_x + ($box_w+$space_left);
                $start_y2 = $start_y + ($box_h+$space_bottom)*$j;
                $txt_x2 = $start_x2 + ceil($box_w/2);
                $txt_y2 = $txt_y + ($box_h+$space_bottom)*$j;
                $mid_point_x1 = $start_x + $box_w/2;
                $mid_point_x2 = $start_x2 + $box_w/2;
                $mid_point_y1 = $start_y + $box_h/2;
                $mid_point_y2 = $start_y2 + $box_h/2;
                $dc_name = '';
                $dc_code = '';

                foreach($dc_data2 as $dc_data3){
                    if ($dc_data3['key'] == $iconn['iconn_to']){
                        $dc_name = $dc_data3['datacenter_name'];
                        $dc_code = $dc_data3['datacenter_code'];
                    }
                }
            
                $html_ret .= "<rect x=\"".$start_x2."\" y=\"".$start_y2."\" rx=\"5\" ry=\"5\" width=\"".$box_w."\" height=\"".$box_h."\" style=\"fill:rgb(255,0,0)\" />";
                $html_ret .= "<text font-family=\"Helvetica\" font-weight=\"bold\" font-size=\"10px\" text-anchor=\"middle\" x=\"".$txt_x2."\" y=\"".$txt_y2."\" fill=\"white\">";
                $html_ret .= "".$dc_code."";
                $html_ret .= "</text>";
                $j++;
            }
        
            $html_ret .= "<rect x=\"".$start_x."\" y=\"".$start_y."\" rx=\"5\" ry=\"5\" width=\"".$box_w."\" height=\"".$box_h."\" style=\"fill:".$bg_color."\" />";
            $html_ret .= "<text font-family=\"Helvetica\" font-weight=\"bold\" font-size=\"10px\" text-anchor=\"middle\" x=\"".$txt_x."\" y=\"".$txt_y."\" fill=\"white\">";
            $html_ret .= "".$dc_data['datacenter_code']."";
            $html_ret .= "</text>";
        }
        
        return $html_ret;
    }
    
    function make_all_dc_interconnect_svg($arr_datacenters_list){
        $arr_dc = [];
        $arr_iconn = [];
        
        
        // coordinates
        $x_pos = 5;
        $y_pos = 5;
        $box_w = 150;
        $box_h = 30;
        $horiz_space = 30;
        $vert_space = 30;
        $x_mid = $x_pos + round($box_w / 2);
        $y_mid = $y_pos + round($box_h / 2);
        $max_per_row = 3;
        $max_rows = ceil(count($arr_datacenters_list['item_list'])/$max_per_row);
        $svg_w = $x_pos + $box_w*$max_per_row + $horiz_space*$max_per_row + 10;
        $svg_h = $y_pos + $box_h*$max_rows + $vert_space*$max_rows + 10;
        
        $i = 0;
        $j = 0;
        
        foreach ($arr_datacenters_list['item_list'] as $dc_info){
            $myarr = utilities_library::mk_array($dc_info['key'],$dc_info['property_list']);
            $arr_dc[$dc_info['key']] = $myarr;
            $iconns = utilities_library::make_iconn_array_from_dc($myarr);
        
            if($i == $max_per_row){
                $i = 0;
                $j++;
            }
        
            if($i == 0 && $j == 0){
                $x2_pos = $x_pos;
                $y2_pos = $y_pos;
            }else if($j == 0 && $i > 0){
                $x2_pos = $x_pos + $box_w*$i + $horiz_space*$i;
                $y2_pos = $y_pos;
            }else if($i == 0 && $j > 0){
                $x2_pos = $x_pos;
                $y2_pos = $y_pos + $box_h*$j + $vert_space*$j;
            }else if($i > 0 && $j > 0){
                $x2_pos = $x_pos + $box_w*$i + $horiz_space*$i;
                $y2_pos = $y_pos + $box_h*$j + $vert_space*$j;
            }
            $x2_mid = $x2_pos + round($box_w / 2);
            $y2_mid = $y2_pos + round($box_h / 2);
            $rgb_col = "".rand(50,180).",".rand(50,180).",".rand(50,180)."";
            if($myarr['active_yn'] == 'True'){
                $arr_iconn[$dc_info['key']] = ['conn'=>$iconns,'conn_count'=>count($iconns),'dc'=>$myarr,'x_pos'=>$x2_pos,'y_pos'=>$y2_pos,'x_mid'=>$x2_mid,'y_mid'=>$y2_mid,'rgb_col'=>$rgb_col];
        
                $i++;
            }
        }
        
        
        $html_ret = "";
        
        
        $html_ret .= "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"".$svg_w."\" height=\"".$svg_h."\" version=\"1.1\">";
        $html_ret .= "<rect x=\"10\" y=\"10\" width=\"".$svg_w."\" height=\"".$svg_h."\" style=\"fill:white\" />";
        
        
        // make connectors first as they need to fall behind
        // the datacenter blocks
        
        foreach($arr_iconn as $dc_iconnects){
            // add a small offset so that no interconnects overlap each other
            $coord_off = 2;
        
            foreach($dc_iconnects['conn'] as $dc_i_conn){
                // increase the offset
                $coord_off = $coord_off + 3;
        
                $to_conn = $dc_i_conn['iconn_to'];
                $x1 = $dc_iconnects['x_mid']+$coord_off;
                $y1 = $dc_iconnects['y_mid']+$coord_off;
                $x2 = $arr_iconn[$to_conn]['x_mid']+$coord_off;
                $y2 = $arr_iconn[$to_conn]['y_mid']+$coord_off;
                $rgb_col = $dc_iconnects['rgb_col'];
                $html_ret .= "<line x1=\"".$x1."\" y1=\"".$y1."\" x2=\"".$x2."\" y2=\"".$y2."\" style=\"stroke:rgb(".$rgb_col.");stroke-width:1\" />";
            }
        }
        
        // make blocks for datacenters
        foreach($arr_iconn as $dc_iconnects){
            $html_ret .= "<rect x=\"".$dc_iconnects['x_pos']."\" y=\"".$dc_iconnects['y_pos']."\" rx=\"5\" ry=\"5\" width=\"".$box_w."\" height=\"".$box_h."\" style=\"fill:rgb(".$dc_iconnects['rgb_col'].")\" />";
            $txt_x_pos = $dc_iconnects['x_mid'];
            $txt_y_pos = $dc_iconnects['y_mid'];
            $html_ret .= "<text font-family=\"Helvetica\" font-weight=\"bold\" font-size=\"10px\" text-anchor=\"middle\" x=\"".$txt_x_pos."\" y=\"".$txt_y_pos."\" fill=\"white\">";
            $html_ret .= "".$dc_iconnects['dc']['datacenter_code']."";
            $html_ret .= "</text>";
        }
        
        $html_ret .= "</svg>";
        
        return $html_ret;
    }
    
    function get_dc_by_id($arr_datacenters_list,$in_dc_id){
        // get datacenter
        $myarr = [];
        foreach ($arr_datacenters_list['item_list'] as $dc_info){
            if($dc_info['key'] == $in_dc_id){
                $myarr = utilities_library::mk_array($dc_info['key'],$dc_info['property_list']);
            }
        }
        return $myarr;
    }
    
    function make_templates_table($in_templates_list, $lang, $cur_page, $start_rec, $end_rec, $arr_labels, $arr_template_data_format, $pgnum = 0){

        $html_ret = "";
        $i = 0;
        if($start_rec > count($in_templates_list)){
            $start_rec = 0;
            $end_rec = $start_rec + MAX_RECS_PER_PAGE;
        }
        foreach ($in_templates_list as $template_data) {

            if ($i >= $start_rec && $i < $end_rec){
                $html_ret .= "<tr>";
                $html_ret .= "<td>".$template_data['template_name']."</td>";
                $html_ret .= "<td>".utilities_library::mk_dt($template_data['modified_on'],'Y-m-d H:i:s.u',DATETIME_FORMAT)."</td>";
                if($template_data['active_yn'] == 'True'){
                    $html_ret .= "<td class=\"text-success\">".formatting_library::make_lang_label($arr_labels, 'lbl_active', $lang)."</td>";
                }else{
                    $html_ret .= "<td class=\"text-danger\">".formatting_library::make_lang_label($arr_labels, 'lbl_inactive', $lang)."</td>";
                }
                $html_ret .= "<td>";
                $html_ret .= "<a href=\"javascript:PopupWindow('template_preview.php?tid=".$template_data['key']."&mode=edit', 600, 600, '');\"><span class=\"glyphicon glyphicon-edit\" title=\"".formatting_library::make_lang_label($arr_labels, 'lbl_template_edit_preview', DEFAULT_LANG)."\"></span></a>&nbsp;&nbsp;";
                $html_ret .= "<a href=\"javascript:PopupWindow('template_preview.php?tid=".$template_data['key']."&mode=preview', 600, 600, '');\"><span class=\"glyphicon glyphicon-eye-open\" title=\"".formatting_library::make_lang_label($arr_labels, 'lbl_template_data_preview', DEFAULT_LANG)."\"></span></a>";
                $html_ret .= "</td>";
                if($template_data['active_yn'] == 'True'){
                    $html_ret .= "<td><a href=\"#detailModal".$template_data['key']."\" data-tid=\"".$template_data['key']."\" data-toggle=\"modal\">".formatting_library::make_lang_label($arr_labels, 'lbl_edit', $lang)."</a> | <a href=\"".$cur_page."?tid=".$template_data['key']."&pg=".$pgnum."&do=deactivate\">".formatting_library::make_lang_label($arr_labels, 'lbl_deactivate', $lang)."</a></td>";
                }else{
                    $html_ret .= "<td><a href=\"#detailModal".$template_data['key']."\" data-tid=\"".$template_data['key']."\" data-toggle=\"modal\">".formatting_library::make_lang_label($arr_labels, 'lbl_edit', $lang)."</a> | <a href=\"".$cur_page."?tid=".$template_data['key']."&pg=".$pgnum."&do=activate\">".formatting_library::make_lang_label($arr_labels, 'lbl_activate', $lang)."</a></td>";
                }

                $html_ret .= "</tr>";
            
                $html_ret .= "<!-- display template modal section for ID ".$template_data['key']." -->";
                $html_ret .= "<form action=\"".$cur_page."?do=save&tid=".$template_data['key']."\" method=\"post\">";
                $html_ret .= "<input type=\"hidden\" name=\"active_yn\" value=\"".$template_data['active_yn']."\">";
                $html_ret .= "<div class=\"modal fade\" id=\"detailModal".$template_data['key']."\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myModalLabel\" aria-hidden=\"true\">";
                $html_ret .= "<div class=\"modal-dialog\">";
                $html_ret .= "<div class=\"modal-content\">";
                $html_ret .= "<div class=\"modal-header\">";
                $html_ret .= "<button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-hidden=\"true\">×</button>";
                $html_ret .= "<h3 id=\"myModalLabel\">".$template_data['template_name']."</h3>";
                $html_ret .= "</div>";
                $html_ret .= "<div class=\"modal-body\">";
                $html_ret .= "<div class=\"span4\">";
                $html_ret .= "".formatting_library::make_form($arr_labels, $arr_template_data_format['info'], $lang, $template_data, null, null);
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "<div class=\"modal-footer\">";
                $html_ret .= "<button class=\"btn btn-danger\" data-dismiss=\"modal\" aria-hidden=\"true\">".formatting_library::make_lang_label($arr_labels, 'lbl_btn_cancel', DEFAULT_LANG)."</button>";
                $html_ret .= "<button class=\"btn btn-success\" type=\"submit\">".formatting_library::make_lang_label($arr_labels, 'lbl_btn_save_template', DEFAULT_LANG)."</button>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "</div>";
                $html_ret .= "</form>";
                $html_ret .= "<!-- end display template modal section for ID ".$template_data['key']." -->";
                
            }
            $i++;
        }
        return $html_ret;
        
    }
    
    function make_devices_table($in_devices_list, $lang, $cur_page, $start_rec, $end_rec, $arr_labels, $arr_device_data_format, $pgnum = 0, $arr_datacenters_key, $arr_templates_key){
        $html_ret = "";
        $i = 0;
        if($start_rec > count($in_devices_list)){
            $start_rec = 0;
            $end_rec = $start_rec + MAX_RECS_PER_PAGE;
        }
        foreach ($in_devices_list as $device_data) {
            
            if ($i >= $start_rec && $i < $end_rec){
                $html_ret .= "<tr>";
                
                $html_ret .= "<td><a href=\"".$cur_page."?did=".$device_data['key']."&pg=".$pgnum."&do=view\">".$device_data['device_name']."</a></td>";
                $html_ret .= "<td>".$device_data['device_domain']."</td>";
                $html_ret .= "<td>".$arr_datacenters_key[$device_data['datacenter_id']]['datacenter_name']."</td>";
                $html_ret .= "<td>".$arr_templates_key[$device_data['template_id']]['template_name']."</td>";
                $html_ret .= "<td>".utilities_library::mk_dt($device_data['modified_on'],'Y-m-d H:i:s.u',DATETIME_FORMAT)."</td>";
                if($device_data['active_yn'] == 'True'){
                    $html_ret .= "<td class=\"text-success\">".formatting_library::make_lang_label($arr_labels, 'lbl_active', $lang)."</td>";
                }else{
                    $html_ret .= "<td class=\"text-danger\">".formatting_library::make_lang_label($arr_labels, 'lbl_inactive', $lang)."</td>";
                }
                if($device_data['active_yn'] == 'True'){
                    $html_ret .= "<td><a href=\"".$cur_page."?did=".$device_data['key']."&pg=".$pgnum."&do=deactivate\">".formatting_library::make_lang_label($arr_labels, 'lbl_deactivate', $lang)."</a> | <a href=\"".$cur_page."?did=".$device_data['key']."&pg=".$pgnum."&do=edit_device\">".formatting_library::make_lang_label($arr_labels, 'lbl_edit', $lang)."</a></td>";
                }else{
                    $html_ret .= "<td><a href=\"".$cur_page."?did=".$device_data['key']."&pg=".$pgnum."&do=activate\">".formatting_library::make_lang_label($arr_labels, 'lbl_activate', $lang)."</a> | <a href=\"".$cur_page."?did=".$device_data['key']."&pg=".$pgnum."&do=edit_device\">".formatting_library::make_lang_label($arr_labels, 'lbl_edit', $lang)."</a></td>";
                }
                $html_ret .= "</tr>";
            }
            $i++;
            
        }
        return $html_ret;
    }
    
    function make_devices_accounts_table($in_device_arr, $arr_crypto_keys, $arr_labels, $display_mode){
        $html_ret = "";
        
        if($display_mode != 'edit' && $display_mode != 'view'){
            $display_mode = 'view';
        }
        if (isset($in_device_arr) && $in_device_arr != '' && count($in_device_arr) > 0 ){
            
            $accts_list = utilities_library::make_accts_array_from_device($in_device_arr);
            
            if($display_mode == 'edit'){
                if($in_device_arr['accounts_count'] > 0 && isset($in_device_arr['accounts_count'])){
                    foreach($accts_list as $single_acct){
    
                        $html_ret .= "<tr>";
                        $html_ret .= "<td><div id=\"devacct_account\"><input id=\"devacct_account\" type=\"text\" name=\"devacct_account[]\" value=\"".$single_acct['devacct_account']."\" /></div></td>";
                        $html_ret .= "<td><div id=\"devacct_account_type\"><input id=\"devacct_account_type\" type=\"text\" name=\"devacct_account_type[]\" value=\"".$single_acct['devacct_account_type']."\" /></div></td>";
                        //$ky = $arr_crypto_keys[$single_acct['devacct_account_key']];
                        //$cp = enc_library::dec_pwd($single_acct['devacct_account_pwd'], $ky['key_pass'], $ky['key_value']);
    
                        $html_ret .= "<td><div id=\"devacct_account_pwd\"><input id=\"devacct_account_pwd\" type=\"password\" name=\"devacct_account_pwd[]\" value=\"".$single_acct['devacct_account_pwd']."\" /></div></td>";
                        $html_ret .= "<td><div id=\"devacct_account_key\"><select id=\"devacct_account_key\" name=\"devacct_account_key[]\">";
                        foreach ($arr_crypto_keys as $ck=>$ck_data){
                            if($single_acct['devacct_account_key'] == $ck){
                                $html_ret .= "<option value=\"".$ck."\" selected>".$ck_data['key_name']."</option>"; 
                            }else{
                                $html_ret .= "<option value=\"".$ck."\">".$ck_data['key_name']."</option>"; 
                            }
                        }
                        $html_ret .= "</select></div></td>";
                        $html_ret .= "<td><div id=\"devacct_account_key_pwd\"><input id=\"devacct_account_key_pwd\" type=\"password\" name=\"devacct_account_key_pwd[]\" value=\"\" /></div></td>";
                        $html_ret .= "<td><input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delAcctkbutton\" onclick=\"delAcctRow('devacct_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_device_del_account', $lang)."\" /></td>";
                        $html_ret .= "</tr>";
                    }
                }else{
                        $html_ret .= "<tr>";
                        $html_ret .= "<td><div id=\"devacct_account\"><input id=\"devacct_account\" type=\"text\" name=\"devacct_account[]\" value=\"\" /></div></td>";
                        $html_ret .= "<td><div id=\"devacct_account_type\"><input id=\"devacct_account_type\" type=\"text\" name=\"devacct_account_type[]\" value=\"\" /></div></td>";
                        $html_ret .= "<td><div id=\"devacct_account_pwd\"><input id=\"devacct_account_pwd\" type=\"password\" name=\"devacct_account_pwd[]\" value=\"\" /></div></td>";
                        $html_ret .= "<td><div id=\"devacct_account_key\"><select id=\"devacct_account_key\" name=\"devacct_account_key[]\">";
                        foreach ($arr_crypto_keys as $ck=>$ck_data){
                            $html_ret .= "<option value=\"".$ck."\">".$ck_data['key_name']."</option>"; 
                        }
                        $html_ret .= "</select></div></td>";
                        $html_ret .= "<td><div id=\"devacct_account_key_pwd\"><input id=\"devacct_account_key_pwd\" type=\"password\" name=\"devacct_account_key_pwd[]\" value=\"\" /></div></td>";
                        $html_ret .= "<td><input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delAcctkbutton\" onclick=\"delAcctRow('devacct_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_device_del_account', $lang)."\" /></td>";
                        $html_ret .= "</tr>";
    
                }
            }else{
                if($in_device_arr['accounts_count'] > 0 && isset($in_device_arr['accounts_count'])){
                    $j = 0;
                    foreach($accts_list as $single_acct){
                        $html_ret .= "<tr>";
                        $html_ret .= "<td valign=\"top\">".$single_acct['devacct_account']."</td>";
                        $html_ret .= "<td valign=\"top\">".$single_acct['devacct_account_type']."</td>";
                        $html_ret .= "<td valign=\"top\">";
                        
                        $html_ret .= "<a href=\"#detailModal".$j."\" data-dcid=\"".$j."\" data-toggle=\"modal\">".formatting_library::make_lang_label($arr_labels, 'lbl_device_account_show_password', $lang)."</a>";
                        
                        $html_ret .= "<!-- display dc modal section for ID ".$j." -->";
                        $html_ret .= "<div class=\"modal fade\" id=\"detailModal".$j."\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myModalLabel\" aria-hidden=\"true\">";
                        $html_ret .= "<div class=\"modal-dialog\">";
                        $html_ret .= "<div class=\"modal-content\">";
                        $html_ret .= "<div class=\"modal-header\">";
                        $html_ret .= "<button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-hidden=\"true\">×</button>";
                        $html_ret .= "<h3 id=\"myModalLabel\">".formatting_library::make_lang_label($arr_labels, 'lbl_device_account_password', $lang)."</h3>";
                        $html_ret .= "</div>";
                        $html_ret .= "<div class=\"modal-body\">";
                        $html_ret .= "<div class=\"form-group\">";
                        $html_ret .= "<form method=\"post\" id=\"pwform_".$j."\" class=\"pwform_".$j."\">";
                        $html_ret .= "".$single_acct['devacct_account_type']." ".formatting_library::make_lang_label($arr_labels, 'lbl_device_account_enc_key_password', $lang).":";
                        $html_ret .= "<br /><input class=\"form-control\" id=\"key_pwd_".$j."\" name=\"key_pwd_".$j."\" type=\"password\" />";
                        $html_ret .= "<input id=\"key_id_".$j."\" name=\"key_id_".$j."\" type=\"hidden\" value=\"".$single_acct['devacct_account_key']."\" />";
                        $html_ret .= "<input id=\"enc_key_".$j."\" name=\"enc_key_".$j."\" type=\"hidden\" value=\"".base64_encode($single_acct['devacct_account_pwd'])."\" />";
                        $html_ret .= "<br /><button class=\"kd kd_sbmt\" id=\"".$j."\" type=\"submit\">".formatting_library::make_lang_label($arr_labels, 'lbl_device_account_show_password', $lang)."</button><br />";
                        $html_ret .= "<div class=\"text-danger\"><span class=\"error\" style=\"display:none\">".formatting_library::make_lang_label($arr_labels, 'lbl_device_account_enc_key_password_np', $lang)."</span></div>";
                        $html_ret .= "<div class=\"text-success\"><span class=\"success\" style=\"display:none\">".formatting_library::make_lang_label($arr_labels, 'lbl_device_account_password', $lang).": <div id=\"kp_".$j."\"></div></span></div>";
                        $html_ret .= "</form>";
                        $html_ret .= "</div>";
                        
                        $html_ret .= "</div>";
                        $html_ret .= "</div>";
                        $html_ret .= "</div>";
                        $html_ret .= "</div>";
                        $html_ret .= "</div>";
                        $html_ret .= "<!-- end display dc modal section for ID ".$j." -->";
                        
                        $html_ret .= "</td>";
                        $html_ret .= "<td valign=\"top\">";
                        foreach ($arr_crypto_keys as $ck=>$ck_data){
                            if($single_acct['devacct_account_key'] == $ck){
                                $html_ret .= $ck_data['key_name']; 
                            }
                        }
                        $html_ret .= "</td>";
                        $html_ret .= "</tr>";
                        $j++;
                    }
                }else{
                    $html_ret .= "<tr><td colspan=\"4\">".formatting_library::make_lang_label($arr_labels, 'lbl_device_no_accounts', DEFAULT_LANG)."</td></tr>";
                }
            }
        }
        
        return $html_ret;
    }
    
    function make_devices_files_table($in_device_arr, $in_files_arr, $arr_labels, $display_mode){
        $html_ret = "";
        
        if($display_mode != 'edit' && $display_mode != 'view'){
            $display_mode = 'view';
        }
        
        if (isset($in_device_arr) && $in_device_arr != '' && count($in_device_arr) > 0 ){
            if($display_mode == 'edit'){
                if($in_files_arr > 0 && isset($in_files_arr) && count($in_files_arr) > 0){
                    foreach($in_files_arr as $single_file){
                        $html_ret .= "<tr>";
                        $html_ret .= "<td><div id=\"devfile_file\"><input type=\"hidden\" id=\"devfile_file_id\" name=\"devfile_file_id[]\" value=\"".$single_file['key']."\" /><input id=\"devfile_file\" type=\"file\" name=\"devfile_file[]\" /> (".$single_file['file_name'].")</div></td>";
                        $html_ret .= "<td><div id=\"devfile_details\"><input id=\"devfile_details\" type=\"text\" name=\"devfile_details[]\" value=\"".$single_file['file_description']."\" /></div></td>";
                        $html_ret .= "<td><input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delDocbutton\" onclick=\"delDocRow('devdoc_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_device_del_document', $lang)."\" /></td>";
                        $html_ret .= "</tr>";
                    }
                }else{
                    $html_ret .= "<tr>";
                    $html_ret .= "<td><div id=\"devfile_file\"><input type=\"hidden\" id=\"devfile_file_id\" name=\"devfile_file_id[]\" value=\"\" /><input id=\"devfile_file\" type=\"file\" name=\"devfile_file[]\" /></div></td>";
                    $html_ret .= "<td><div id=\"devfile_details\"><input id=\"devfile_details\" type=\"text\" name=\"devfile_details[]\" value=\"\" /></div></td>";
                    $html_ret .= "<td><input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delDocbutton\" onclick=\"delDocRow('devdoc_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_device_del_document', $lang)."\" /></td>";
                    $html_ret .= "</tr>";
                }
            }else{
                if($in_files_arr > 0 && isset($in_files_arr) && count($in_files_arr) > 0){
                    foreach($in_files_arr as $single_file){
                        $html_ret .= "<tr>";
                        $html_ret .= "<td><a href=\"".WEB_ADDRESS."getfile.php?file_id=".$single_file['key']."\">".$single_file['file_name']."</a></td>";
                        $html_ret .= "<td>".$single_file['file_type']."</td>";
                        $html_ret .= "<td>".round($single_file['file_size']/1024,2)." Kb</td>";
                        $html_ret .= "<td>".$single_file['file_description']."</td>";
                        $html_ret .= "</tr>";
                    }
                }else{
                    $html_ret .= "<tr><td colspan=\"4\">".formatting_library::make_lang_label($arr_labels, 'lbl_device_no_documents', DEFAULT_LANG)."</td></tr>";
                }
            }
        }
        
        return $html_ret;
    }
    
    function make_devices_processes_table($in_device_arr, $arr_labels, $display_mode){
        $html_ret = "";
        
        if($display_mode != 'edit' && $display_mode != 'view'){
            $display_mode = 'view';
        }
        
        $in_procs_arr = utilities_library::make_procs_array_from_device($in_device_arr);
        
        if (isset($in_device_arr) && $in_device_arr != '' && count($in_device_arr) > 0 ){
            if($display_mode == 'edit'){
                if($in_procs_arr > 0 && isset($in_procs_arr) && count($in_procs_arr) > 0){
                    foreach($in_procs_arr as $single_proc){
                        $html_ret .= "<tr>";
                        $html_ret .= "<td><div id=\"devproc_acct\"><input id=\"devproc_acct\" type=\"text\" name=\"devproc_acct[]\" value=\"".$single_proc['devproc_acct']."\" /></div></td>";
                        $html_ret .= "<td><div id=\"devproc_path\"><input id=\"devproc_path\" type=\"text\" name=\"devproc_path[]\" value=\"".$single_proc['devproc_path']."\" /></div></td>";
                        $html_ret .= "<td><div id=\"devproc_schedule\"><input id=\"devproc_schedule\" type=\"text\" name=\"devproc_schedule[]\" value=\"".$single_proc['devproc_schedule']."\" /></div></td>";
                        $html_ret .= "<td><div id=\"devproc_notes\"><textarea id=\"devproc_notes\" type=\"text\" name=\"devproc_notes[]\">".$single_proc['devproc_notes']."</textarea></div></td>";
                        $html_ret .= "<td><input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delProcbutton\" onclick=\"delProcRow('devproc_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_device_del_process', $lang)."\" /></td>";
                        $html_ret .= "</tr>";
                    }
                }else{
                    $html_ret .= "<tr>";
                    $html_ret .= "<td><div id=\"devproc_acct\"><input id=\"devproc_acct\" type=\"text\" name=\"devproc_acct[]\" /></div></td>";
                    $html_ret .= "<td><div id=\"devproc_path\"><input id=\"devproc_path\" type=\"text\" name=\"devproc_path[]\" value=\"\" /></div></td>";
                    $html_ret .= "<td><div id=\"devproc_schedule\"><input id=\"devproc_schedule\" type=\"text\" name=\"devproc_schedule[]\" value=\"\" /></div></td>";
                    $html_ret .= "<td><div id=\"devproc_notes\"><textarea id=\"devproc_notes\" type=\"text\" name=\"devproc_notes[]\"></textarea></div></td>";
                    $html_ret .= "<td><input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delProcbutton\" onclick=\"delProcRow('devproc_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_device_del_process', $lang)."\" /></td>";
                    $html_ret .= "</tr>";
                }
            }else{
                if($in_procs_arr > 0 && isset($in_procs_arr) && count($in_procs_arr) > 0){
                    foreach($in_procs_arr as $single_proc){
                        $html_ret .= "<tr>";
                        $html_ret .= "<td valign=\"top\">".$single_proc['devproc_acct']."</td>";
                        $html_ret .= "<td valign=\"top\">".$single_proc['devproc_path']."</td>";
                        $html_ret .= "<td valign=\"top\">".$single_proc['devproc_schedule']."</td>";
                        $html_ret .= "<td valign=\"top\">".$single_proc['devproc_notes']."</td>";
                        $html_ret .= "</tr>";
                    }
                }else{
                    $html_ret .= "<tr><td colspan=\"4\">".formatting_library::make_lang_label($arr_labels, 'lbl_device_no_processes', DEFAULT_LANG)."</td></tr>";
                }
            }
        }
        
        return $html_ret;
    }
    
    
    function make_devices_interconnects_table($in_device_arr, $in_all_devices_arr, $arr_labels, $display_mode){
        
        $html_ret = "";
        
        if($display_mode != 'edit' && $display_mode != 'view'){
            $display_mode = 'view';
        }
        
        $in_ic_arr = utilities_library::make_interconnects_array_from_device($in_device_arr);
        
        $dd_devs = [];
        $i = 0;
        foreach ($in_all_devices_arr as $devs_list){
          if($in_device_arr['key'] != $devs_list['key']){
              $dd_devs[] = ['device_name' => $devs_list['device_name'], 'device_domain' => $devs_list['device_domain'], 'device_id' => $devs_list['key']];
              $i++;
          }
        }
        
        if (isset($in_device_arr) && $in_device_arr != '' && count($in_device_arr) > 0 ){
            if($display_mode == 'edit'){
                if($in_ic_arr > 0 && isset($in_ic_arr) && count($in_ic_arr) > 0){
                    foreach($in_ic_arr as $single_ic){
                        $html_ret .= "<tr>";
                        $html_ret .= "<td><div id=\"devic_to\">";
                        $html_ret .= "<select id=\"devic_to\" name=\"devic_to[]\">";
                        foreach($dd_devs as $_s_dev){
                            if($_s_dev['device_id'] == $single_ic['devic_to']){
                                $html_ret .= "<option value=\"".$_s_dev['device_id']."\" selected>".$_s_dev['device_name'].".".$_s_dev['device_domain']."</option>";
                            }else{
                                $html_ret .= "<option value=\"".$_s_dev['device_id']."\">".$_s_dev['device_name'].".".$_s_dev['device_domain']."</option>";
                            }
                        }
                        $html_ret .= "</select>";
                        $html_ret .= "</div></td>";
                        $html_ret .= "<td><div id=\"devic_protocol\"><input id=\"devic_protocol\" type=\"text\" name=\"devic_protocol[]\" value=\"".$single_ic['devic_protocol']."\" /></div></td>";
                        $html_ret .= "<td><div id=\"devic_port\"><input id=\"devic_port\" type=\"text\" name=\"devic_port[]\" value=\"".$single_ic['devic_port']."\" /></div></td>";
                        $html_ret .= "<td><div id=\"devic_notes\"><textarea id=\"devic_notes\" type=\"text\" name=\"devic_notes[]\">".$single_ic['devic_notes']."</textarea></div></td>";
                        $html_ret .= "<td><input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delICbutton\" onclick=\"delICRow('devic_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_device_del_interconnect', $lang)."\" /></td>";
                        $html_ret .= "</tr>";
                    }
                }else{
                    $html_ret .= "<tr>";
                    $html_ret .= "<td><div id=\"devic_to\">";
                    $html_ret .= "<select id=\"devic_to\" name=\"devic_to[]\">";
                    foreach($dd_devs as $_s_dev){
                        $html_ret .= "<option value=\"".$_s_dev['device_id']."\">".$_s_dev['device_name'].".".$_s_dev['device_domain']."</option>";
                    }
                    $html_ret .= "</select>";
                    $html_ret .= "</div></td>";
                    $html_ret .= "<td><div id=\"devic_protocol\"><input id=\"devic_protocol\" type=\"text\" name=\"devic_protocol[]\" value=\"\" /></div></td>";
                    $html_ret .= "<td><div id=\"devic_port\"><input id=\"devic_port\" type=\"text\" name=\"devic_port[]\" value=\"\" /></div></td>";
                    $html_ret .= "<td><div id=\"devic_notes\"><textarea id=\"devic_notes\" type=\"text\" name=\"devic_notes[]\"></textarea></div></td>";
                    $html_ret .= "<td><input type=\"button\" class=\"btn btn-danger btn-group-sm\" id=\"delICbutton\" onclick=\"delICRow('devic_table_tb',this)\" value=\"".formatting_library::make_lang_label($arr_labels, 'lbl_device_del_interconnect', $lang)."\" /></td>";
                    $html_ret .= "</tr>";
                }
            }else{
                if($in_ic_arr > 0 && isset($in_ic_arr) && count($in_ic_arr) > 0){
                    foreach($in_ic_arr as $single_ic){
                        $html_ret .= "<tr>";
                        $html_ret .= "<td valign=\"top\">";
                        foreach($dd_devs as $_s_dev){
                            if($_s_dev['device_id'] == $single_ic['devic_to']){
                                $html_ret .= $_s_dev['device_name'].".".$_s_dev['device_domain'];
                            }
                        }
                        $html_ret .= "</td>";
                        $html_ret .= "<td valign=\"top\">".$single_ic['devic_protocol']."</td>";
                        $html_ret .= "<td valign=\"top\">".$single_ic['devic_port']."</td>";
                        $html_ret .= "<td valign=\"top\">".$single_ic['devic_notes']."</td>";
                        $html_ret .= "</tr>";
                    }
                }else{
                    $html_ret .= "<tr><td colspan=\"4\">".formatting_library::make_lang_label($arr_labels, 'lbl_device_no_interconnects', DEFAULT_LANG)."</td></tr>";
                }
            }
        }
        
        return $html_ret;
    }
    
    function select_datacenters_ds($do_refresh = false, $show_inactive = false){
        $datacenters_ds = [];
        if ($do_refresh == false){
            if (!isset($_SESSION['datacenters_list'])){
                $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
                $rest_client = new rest_client($_SESSION['auth_head'],'');
                $datacenters_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/datacenters',json_encode($comp_id,true));
                $arr_datacenters_list = json_decode($datacenters_list_return, true);
                if(count($arr_datacenters_list) > 0){
                    $_SESSION['datacenters_list'] = $arr_datacenters_list;
                    $_SESSION['datacenters_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
                }else{
                    $_SESSION['datacenters_list'] = null;
                    $_SESSION['datacenters_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
                }
            }
        }else{
            $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
            $rest_client = new rest_client($_SESSION['auth_head'],'');
            $datacenters_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/datacenters',json_encode($comp_id,true));
            $arr_datacenters_list = json_decode($datacenters_list_return, true);
            if(count($arr_datacenters_list) > 0){
                $_SESSION['datacenters_list'] = $arr_datacenters_list;
                $_SESSION['datacenters_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            }else{
                $_SESSION['datacenters_list'] = null;
                $_SESSION['datacenters_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            }
        }

        if(count($_SESSION['datacenters_list']['item_list']) > 0){
            foreach ($_SESSION['datacenters_list']['item_list'] as $obj_data){
                $myarr = utilities_library::mk_array($obj_data['key'],$obj_data['property_list']);
                if ($show_inactive == true){
                    $datacenters_ds = $datacenters_ds+[$obj_data['key']=>$myarr['datacenter_name']];
                }else{
                    if($myarr['active_yn'] == 'True'){
                        $datacenters_ds = $datacenters_ds+[$obj_data['key']=>$myarr['datacenter_name']];
                    }
                }
            }
        }
        return $datacenters_ds;
    }
    
    function select_users_ds($do_refresh = false, $show_inactive = false){
        $users_ds = [];
        if ($do_refresh == false){
            if (!isset($_SESSION['users_list'])){
                $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
                $rest_client = new rest_client($_SESSION['auth_head'],'');
                $users_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/user',json_encode($comp_id,true));
                $arr_users_list = json_decode($users_list_return, true);
                if(count($arr_users_list) > 0){
                    $_SESSION['users_list'] = $arr_users_list;
                    $_SESSION['users_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
                }else{
                    $_SESSION['users_list'] = null;
                    $_SESSION['users_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
                }
            }
        }else{
            $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
            $rest_client = new rest_client($_SESSION['auth_head'],'');
            $users_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/users',json_encode($comp_id,true));
            $arr_users_list = json_decode($users_list_return, true);
            if(count($arr_users_list) > 0){
                $_SESSION['users_list'] = $arr_users_list;
                $_SESSION['users_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            }else{
                $_SESSION['users_list'] = null;
                $_SESSION['users_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            }
        }
    
        if(count($_SESSION['users_list']['item_list']) > 0){
            foreach ($_SESSION['users_list']['item_list'] as $obj_data){
                $myarr = utilities_library::mk_array($obj_data['key'],$obj_data['property_list']);
                if ($show_inactive == true){
                    $users_ds = $users_ds+[$obj_data['key']=>$myarr['user_name']];
                }else{
                    if($myarr['active_yn'] == 'True'){
                        $users_ds = $users_ds+[$obj_data['key']=>$myarr['user_name']];
                    }
                }
            }
        }
        return $users_ds;
    }
    
    function select_files_ds($do_refresh = false, $file_class = 'DEVICE', $class_id){
        $files_ds = [];
        if ($do_refresh == false){
            if (!isset($_SESSION['files_list'])){
                $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id'],'file_class' => $file_class,'class_id'=>$class_id];
                $rest_client = new rest_client($_SESSION['auth_head'],'');
                $files_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/files',json_encode($comp_id,true));
                $arr_files_list = json_decode($files_list_return, true);
                if(count($arr_files_list) > 0){
                    $_SESSION['files_list'] = $arr_files_list;
                    $_SESSION['files_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
                }else{
                    $_SESSION['files_list'] = null;
                    $_SESSION['files_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
                }
            }
        }else{
            $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id'],'file_class' => $file_class,'class_id'=>$class_id];
            $rest_client = new rest_client($_SESSION['auth_head'],'');
            $files_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/files',json_encode($comp_id,true));
            $arr_files_list = json_decode($files_list_return, true);
            if(count($arr_files_list) > 0){
                $_SESSION['files_list'] = $arr_files_list;
                $_SESSION['files_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            }else{
                $_SESSION['files_list'] = null;
                $_SESSION['files_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            }
        }
    
        if(count($_SESSION['files_list']['item_list']) > 0){
            foreach ($_SESSION['files_list']['item_list'] as $obj_data){
                $myarr = utilities_library::mk_array($obj_data['key'],$obj_data['property_list']);
                $files_ds = $files_ds+[$obj_data['key']=>$myarr['file_name']];
            }
        }
        return $files_ds;
    }

    function select_templates_ds($do_refresh = false, $show_inactive = false){
        $templates_ds = [];
        if ($do_refresh == false){
            if (!isset($_SESSION['templates_list'])){
                $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
                $rest_client = new rest_client($_SESSION['auth_head'],'');
                $templates_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/templates',json_encode($comp_id,true));
                $arr_templates_list = json_decode($templates_list_return, true);
                if(count($arr_templates_list) > 0){
                    $_SESSION['templates_list'] = $arr_templates_list;
                    $_SESSION['templates_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
                }else{
                    $_SESSION['templates_list'] = null;
                    $_SESSION['templates_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
                }
            }
        }else{
            $comp_id = ['company_id' => $_SESSION['auth_head']['auth_head_company_id']];
            $rest_client = new rest_client($_SESSION['auth_head'],'');
            $templates_list_return = $rest_client->listobj(WEB_SERVICE_ADDRESS.'/users',json_encode($comp_id,true));
            $arr_templates_list = json_decode($templates_list_return, true);
            if(count($arr_templates_list) > 0){
                $_SESSION['templates_list'] = $arr_templates_list;
                $_SESSION['templates_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            }else{
                $_SESSION['templates_list'] = null;
                $_SESSION['templates_list_create_dt'] = gmdate("Y-m-d H:i:s", time());
            }
        }

        if(count($_SESSION['templates_list']['item_list']) > 0){
            foreach ($_SESSION['templates_list']['item_list'] as $obj_data){
                $myarr = utilities_library::mk_array($obj_data['key'],$obj_data['property_list']);
                if ($show_inactive == true){
                    $templates_ds = $templates_ds+[$obj_data['key']=>$myarr['template_name']];
                }else{
                    if($myarr['active_yn'] == 'True'){
                        $templates_ds = $templates_ds+[$obj_data['key']=>$myarr['template_name']];
                    }
                }
            }
        }
        return $templates_ds;
    }
    
    function arr_cnt_by_filter($in_arr,$filter1, $filter_value1, $filter2, $filter_value2){
        $myret = [];

        $tot_cnt = 0;
        $inact_cnt = 0;
        $inact_cnt_perc = 0;
        $act_cnt = 0;
        $act_cnt_perc = 0;
        foreach ($in_arr as $obj_data){
            if($obj_data[$filter1] == $filter_value1 && $obj_data[$filter2] == $filter_value2){
                if($obj_data['active_yn'] == 'True'){
                   $act_cnt++; 
                }
                if($obj_data['active_yn'] == 'False'){
                    $inact_cnt++;
                }
                $tot_cnt++;
            }
        }
        $act_cnt_perc = round($act_cnt*100/$tot_cnt,2);
        $inact_cnt_perc = round($inact_cnt*100/$tot_cnt,2);
        $myret['all'] = $tot_cnt;
        $myret['inactive_cnt'] = $inact_cnt;
        $myret['inactive_perc'] = $inact_cnt_perc;
        $myret['active_cnt'] = $act_cnt;
        $myret['active_perc'] = $act_cnt_perc;
        return $myret;
        
        
    }
    
    function simple_arr_cnt_by_filter($in_arr,$filter1, $filter_value1){
        $myret = [];

        $tot_cnt = 0;
        $inact_cnt = 0;
        $inact_cnt_perc = 0;
        $act_cnt = 0;
        $act_cnt_perc = 0;
        foreach ($in_arr as $obj_data){
            if($obj_data[$filter1] == $filter_value1){
                if($obj_data['active_yn'] == 'True'){
                   $act_cnt++; 
                }
                if($obj_data['active_yn'] == 'False'){
                    $inact_cnt++;
                }
                $tot_cnt++;
            }
        }
        $act_cnt_perc = round($act_cnt*100/$tot_cnt,2);
        $inact_cnt_perc = round($inact_cnt*100/$tot_cnt,2);
        $myret['all'] = $tot_cnt;
        $myret['inactive_cnt'] = $inact_cnt;
        $myret['inactive_perc'] = $inact_cnt_perc;
        $myret['active_cnt'] = $act_cnt;
        $myret['active_perc'] = $act_cnt_perc;
        return $myret;
    }
    
    function make_devices_downtime_impact($in_device_arr, $in_all_devices_arr, $arr_labels){
        $html = "";
        
        $in_ic_arr = utilities_library::make_interconnects_array_from_device($in_device_arr);
        $in_proc_arr = utilities_library::make_procs_array_from_device($in_device_arr);

        if(count($in_ic_arr) == 0 && count($in_proc_arr) == 0){
            $html .= formatting_library::make_lang_label($arr_labels,'lbl_device_no_downtime_impact',DEFAULT_LANG);
        }else{
            if(count($in_proc_arr) > 0){
                $html .= formatting_library::make_lang_label($arr_labels,'lbl_device_downtime_impact_procs',DEFAULT_LANG);
                $html .= "<table id=\"devproc_table_tb\" class=\"table table-striped\">";
                $html .= "<tr>";
                $html .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_device_process_account', DEFAULT_LANG)."</th>";
                $html .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_device_process_path', DEFAULT_LANG)."</th>";
                $html .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_device_process_schedule', DEFAULT_LANG)."</th>";
                $html .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_device_process_notes', DEFAULT_LANG)."</th>";
                $html .= "</tr>";
                $html .= utilities_library::make_devices_processes_table($in_device_arr,$arr_labels,'view');
                $html .= "</table>";
            }
            if(count($in_ic_arr) > 0){
                $html .= formatting_library::make_lang_label($arr_labels,'lbl_device_downtime_impact_ics',DEFAULT_LANG);
                $html .= "<table id=\"devic_table_tb\" class=\"table table-striped\">";
                $html .= "<tr>";
                $html .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_device_interconnect_to', DEFAULT_LANG)."</th>";
                $html .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_device_interconnect_protocol', DEFAULT_LANG)."</th>";
                $html .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_device_interconnect_port', DEFAULT_LANG)."</th>";
                $html .= "<th>".formatting_library::make_lang_label($arr_labels, 'lbl_device_interconnect_notes', DEFAULT_LANG)."</th>";
                $html .= "</tr>";
                $html .= utilities_library::make_devices_interconnects_table($in_device_arr,$in_all_devices_arr,$arr_labels,'view');
                $html .= "</table>";
            }
        }
        
        return $html;
    }
    
    function make_devices_tickets_table($in_device_arr, $in_tickets_arr, $arr_labels){
        $html = "";

        if(count($in_tickets_arr) > 0){
            
            rsort($in_tickets_arr);
            $html .= "<table id=\"devtickets_table_tb\" class=\"table table-striped\">";
            
            foreach ($in_tickets_arr as $ticket_data){
                if($ticket_data['active_yn'] == 'True'){
                    $html .= "<tr>";
                    $html .= "<td><b>".formatting_library::make_lang_label($arr_labels, 'lbl_device_ticket', DEFAULT_LANG).": </b>";
                    if ($ticket_data['ticket_link'] == "#"){
                        $html .= $ticket_data['ticket_number'];
                    }else{
                        $html .= "<a href=\"".$ticket_data['ticket_link']."\" target=\"_blank\">".$ticket_data['ticket_number']."</a>";
                    }
                    $html .= "</td>";
                    $html .= "</tr>";
                    $html .= "<tr>";
                    $html .= "<td>";
                    $html .= "<b>".formatting_library::make_lang_label($arr_labels, 'lbl_device_ticket_reported_on', DEFAULT_LANG).": </b>".utilities_library::mk_dt($ticket_data['created_on'],'Y-m-d H:i:s.u',DATETIME_FORMAT)."<br />";
                    $html .= "<b>".formatting_library::make_lang_label($arr_labels, 'lbl_device_ticket_reported_by', DEFAULT_LANG).": </b>".$ticket_data['ticket_reported_by']."<br />";
                    $html .= "<b>".formatting_library::make_lang_label($arr_labels, 'lbl_device_ticket_issue', DEFAULT_LANG).": </b>".base64_decode($ticket_data['ticket_issue'])."<br />";
                    $html .= "<b>".formatting_library::make_lang_label($arr_labels, 'lbl_device_ticket_last_update', DEFAULT_LANG).": </b>".utilities_library::mk_dt($ticket_data['modified_on'],'Y-m-d H:i:s.u',DATETIME_FORMAT)."<br />";
                    $html .= "<b>".formatting_library::make_lang_label($arr_labels, 'lbl_device_ticket_resolved_by', DEFAULT_LANG).": </b>".$ticket_data['ticket_solved_by']."<br />";
                    $html .= "<b>".formatting_library::make_lang_label($arr_labels, 'lbl_device_ticket_solution', DEFAULT_LANG).": </b>".base64_decode($ticket_data['ticket_solution'])."<br />";
                    $html .= "</td>";
                    $html .= "</tr>";
                }
                
            }
            
            
            $html .= "</table>";
            
        }else{
            $html .= formatting_library::make_lang_label($arr_labels, 'lbl_device_no_tickets', DEFAULT_LANG);
        }
        
        return $html;
    }
    
}

$utilities_library = new utilities_library();

?>
