<?php
/*
*
* Copyright (c) 2014 AM Data Soft
* Distributed under the GNU GPL v3.
* License: http://www.gnu.org/licenses/gpl.html GPL version 3 or higher
*
*/

/*
*
* Purpose:         Global settings page
*                  If for any reason you would like to use a different configuration ini 
*                  file, or change the location of the ini file, change he path in line 45:
* 
*                  $app_settings_array = parse_ini_file("/etc/infratrack/infratrack_WEB.ini");
* 
*                  If the desired default timezone must be changed from UTC, change on line 
*                  82 with desired value:
* 
*                  define('DEFAULT_TIMEZONE', 'UTC');
* 
*                  Note that the default timezone is being used only when the user and company 
*                  does not have a timezone pre-defined. In most cases, this is impossible, 
*                  so changing line 60 should never be a requirement.
* 
*                  If the desired default language must be changed from en_US (English, USA), 
*                  change on line 71 with desired value:
* 
*                  define('DEFAULT_LANG', 'en_US');
* 
*                  Note that the default language is being used only when the user and company 
*                  does not have a language pre-defined. In most cases, this is impossible, 
*                  so changing line 71 should never be a requirement.
* 
* 
* 
* Developer:       AM Data Soft
* Version:         1.0
* Version date:    2014-04-10
*
*/


$app_settings_array = parse_ini_file("/etc/infratrack/infratrack_WEB.ini");

define('MEMORY_LIMIT',$app_settings_array['MEMORY_LIMIT']);
define('ERROR_LEVEL',$app_settings_array['ERROR_LEVEL']);
define('APP_NAME',$app_settings_array['APP_NAME']);
define('URL_PATH',$app_settings_array['URL_PATH']);
define('COMPANY_ID',$app_settings_array['COMPANY_ID']);
define('WEB_SERVICE_ADDRESS',$app_settings_array['WEB_SERVICE_ADDRESS']);
define('WEB_ROOT',$app_settings_array['WEB_ROOT']);
define('WEB_ADDRESS',$app_settings_array['WEB_ADDRESS']);
define('MAX_RECS_PER_PAGE',$app_settings_array['MAX_RECS_PER_PAGE']);
define('DATETIME_FORMAT',$app_settings_array['DATETIME_FORMAT']);
define('RSS_FEED',$app_settings_array['RSS_FEED']);
define('RSS_ITEMS',$app_settings_array['RSS_ITEMS']);
define('MAP_CENTER_LAT',$app_settings_array['MAP_CENTER_LAT']);
define('MAP_CENTER_LONG',$app_settings_array['MAP_CENTER_LONG']);
define('MAP_ZOOM',$app_settings_array['MAP_ZOOM']);

ini_set('memory_limit', MEMORY_LIMIT);
error_reporting(ERROR_LEVEL);

require_once('lib/timezones.php');
require_once('lib/languages.php');
require_once('lib/access_levels.php');
require_once('lib/form_fields.php');
require_once('lib/cls_formatting.php');
require_once('lib/utils.php');
require_once('lib/enc_module.php');

// attempt to set the timezone to user's preference
if(isset($_SESSION['user_data']['timezone']) && in_array($_SESSION['user_data']['timezone'], $arr_timezones)){
    define('DEFAULT_TIMEZONE', $_SESSION['user_data']['timezone']);
// if no luck, set the timezone to company's preference
}else if(isset($_SESSION['company_data']['timezone']) && in_array($_SESSION['company_data']['timezone'], $arr_timezones)){
    define('DEFAULT_TIMEZONE', $_SESSION['company_data']['timezone']);
}else{
// well; how about UTC?
    define('DEFAULT_TIMEZONE', 'UTC');
}

// attempt to set the language code to user's preference
if(isset($_SESSION['user_data']['lang_env']) && array_key_exists($_SESSION['user_data']['lang_env'], $arr_languages)){
    define('DEFAULT_LANG', $_SESSION['user_data']['lang_env']);
    // if no luck, set the language code to company's preference
}else if(isset($_SESSION['company_data']['lang_env']) && array_key_exists($_SESSION['company_data']['lang_env'], $arr_languages)){
    define('DEFAULT_LANG', $_SESSION['company_data']['lang_env']);
}else{
    // well; how about English?
    define('DEFAULT_LANG', 'en_US');
}

$domain = "infratrack";
$locale = "".DEFAULT_LANG.".utf8";
putenv("LC_ALL=$locale");
setlocale(LC_ALL, $locale);
bindtextdomain($domain, "".WEB_ROOT."/locale");
textdomain($domain);
bind_textdomain_codeset($domain, 'UTF-8');

?>
