<?php
/*
*
* Copyright (c) 2014 AM Data Soft
* Distributed under the GNU GPL v3.
* License: http://www.gnu.org/licenses/gpl.html GPL version 3 or higher
*
*/

/*
*
* Purpose:         Template preview from XSLT to HTML
*                  DO NOT modify this file. Changing this file may void your support
* 
* Developer:       AM Data Soft
* Version:         1.0
* Version date:    2014-04-10
*
*/

session_start();

require_once('settings.php');

date_default_timezone_set(DEFAULT_TIMEZONE);
define('SID', session_id());
define('CURRENT_PAGE', $_SERVER['SCRIPT_NAME']);
define('CURRENT_SCRIPT', $_SERVER['SCRIPT_FILENAME']);
define('CURRENT_URL',$_SERVER['REQUEST_URI']);

require_once(WEB_ROOT.'/lib/rest_client.php');
require_once(WEB_ROOT.'/incl/security.php');

if($_SESSION['user_data']['access_level'] != 'ADMIN' && $_SESSION['user_data']['access_level'] != 'MANAGER'){
    header('location: dashboard.php');
}

// define data variables
$err_msg = "";
$arr_template = [];

// define tid (template id) variable
$tid = "";
if (isset($_GET['tid']) && strlen($_GET['tid']) == 36){
    $tid = $_GET['tid'];
}

// define page mode variable
$mode = "";
if (isset($_GET['mode']) && ($_GET['mode'] == 'edit' || $_GET['mode'] == 'preview')){
    $mode = $_GET['mode'];
}

if($tid != '' && $mode != ''){
    $template_id = ['template_id' => $tid];
    $rest_client = new rest_client($_SESSION['auth_head'],'');
    $template_return = $rest_client->get(WEB_SERVICE_ADDRESS.'/templates',json_encode($template_id,true));
    $arr_templates_data = json_decode($template_return, true);
    if(count($arr_templates_data) > 0){
        $arr_template = $utilities_library->mk_array($arr_templates_data['key'],$arr_templates_data['property_list']);
    }
}else{
    $err_msg = $formatting_library->make_lang_label($arr_labels, 'lbl_err_string', DEFAULT_LANG);
}
if (isset($arr_template) && $arr_template['template_name'] != ''){
    // nothing
}else{
    $err_msg = $formatting_library->make_lang_label($arr_labels, 'lbl_err_no_such_template', DEFAULT_LANG);
}

require_once(WEB_ROOT.'/incl/top.php');

?>

<body>

    <div class="navbar navbar-inverse navbar-fixed-top">
      <div class="container">
        <div class="navbar-header">

          <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="#"><?php echo APP_NAME; ?></a>
        </div>
      </div><!--/.nav-collapse -->
    </div>

<div class="container">

    <?php
        if($err_message != ''){
            print "<div class=\"alert alert-danger\"><b>".$formatting_library->make_lang_label($arr_labels, 'lbl_err_head', DEFAULT_LANG).":</b><br />".$err_message."</div>";
        }else{
            $obj_data = [];
            $xhtml_data = $formatting_library->cmdbxsl_to_xhtml(base64_decode($arr_template['template_code']),$arr_labels,DEFAULT_LANG, $arr_device_data_format['device'],$obj_data,$mode);
            print "<br />".$xhtml_data;
        }
    ?>

<?php
require_once(WEB_ROOT.'/incl/bottom.php');
?>
